<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Ecommerce extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for ecommerce section
     return array(
                  'allowed_section'               => WM3_cSECTION_ECOMMERCE,
                  'allow_category_description'    => false,
                  'allow_subcategory_description' => false,
                  'category_form'                 => 'admin_ecommerce_category_form.inc',
                  'search_form'                   => 'admin_download_search_form.inc',
                  'subcategory_form'              => 'admin_ecommerce_subcategory_form.inc',
                  'table_categories'              => '_ecommerce_categories',
                  'table_subcategories'           => '_ecommerce_subcategories',
                  'table_subcategories_count'     => '_ecommerce_subcategories',
                  'table_items_count'             => '_ecommerce_products',
                  'action_save_category'          => WM3_cACTION_SAVE_ECOMMERCE_CATEGORY,
                  'action_update_category'        => WM3_cACTION_UPDATE_ECOMMERCE_CATEGORY,
                  'action_show_subcategory'       => WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY,
                  'action_add_subcategory'        => WM3_cACTION_ADD_ECOMMERCE_SUBCATEGORY,
                  'action_disable_category'       => WM3_cACTION_DISABLE_ECOMMERCE_CATEGORY,
                  'action_enable_category'        => WM3_cACTION_ENABLE_ECOMMERCE_CATEGORY,
                  'action_edit_category'          => WM3_cACTION_EDIT_ECOMMERCE_CATEGORY,
                  'action_delete_category'        => WM3_cACTION_DELETE_ECOMMERCE_CATEGORY,
                  'action_update_subcategory'     => WM3_cACTION_UPDATE_ECOMMERCE_SUBCATEGORY,
                  'action_save_subcategory'       => WM3_cACTION_SAVE_ECOMMERCE_SUBCATEGORY,
                  'action_show_items'             => WM3_cACTION_SHOW_ECOMMERCE_PRODUCT,
                  'action_add_item'               => WM3_cACTION_ADD_ECOMMERCE_PRODUCT,
                  'action_disable_subcategory'    => WM3_cACTION_DISABLE_ECOMMERCE_SUBCATEGORY,
                  'action_enable_subcategory'     => WM3_cACTION_ENABLE_ECOMMERCE_SUBCATEGORY,
                  'action_edit_subcategory'       => WM3_cACTION_EDIT_ECOMMERCE_SUBCATEGORY,
                  'action_delete_subcategory'     => WM3_cACTION_DELETE_ECOMMERCE_SUBCATEGORY,
                  'action_search'                 => WM3_cACTION_SHOW_ECOMMERCE_PRODUCT,
                  'label_category_list_title'     => 1664,
                  'label_subcategory_add'         => 1663,
                  'label_subcategories_count'     => 1051,
                  'label_items_count'             => 1681,
                  'label_item_add'                => 1665);
    }

   public static function getEcommerceProductFieldsArray()
    {
     return array('productID','subcategoryID','userID','code','name','render_mode','description','full_description','align',
                  'price','price_description','discount','special',
                  'availability','stock','options','enabled','languageID','ts','categoryID');
    }

   public static function getEcommercePictureFieldsArray()
    {
     return array('pictureID','productID','picture_from','picture_from_local','picture','picture_from_remote','thumbnail_from','thumbnail_from_local','thumbnail','thumbnail_from_remote','description','enabled','languageID','ts','categoryID','subcategoryID');
    }

   public static function getEcommerceCartItemFieldsArray()
    {
     return array('cart_itemID','productID','userID','orderID','product_code','product_name','product_description','options','quantity','price','discount',
				  'enabled','languageID','ts');
    }

   public static function getEcommerceProductInformationFieldsArray()
    {
     return array('name','email','message','newsletter','subject','message_head');
    }

   public static function getEcommerceProductSendToFriendFieldsArray()
    {
     return array('name','your_email','friend_email','message','newsletter','subject','message_head');
    }

   public static function getEcommerceOrderItemFieldsArray()
    {
     return array('orderID','userID','order_ts','status','shipping_cost','enabled','languageID','ts');
    }


   public static function getEcommerceProductCustomDataFieldsArray()
    {
     return array('dataID','productID','fieldID','value','enabled','languageID','ts');
    }

   public static function getEcommerceProductCustomFieldValueArray()
    {
     $query = "SELECT *
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
               WHERE  enabled='".WM3_cENABLED."'
			   ORDER BY ts DESC";
     $rs = wm3Sql::sqlQuery($query);
	 $_ARRAY = array();
     while($row = mysql_fetch_object($rs))
      {
       $field = wm3Ecommerce::getCustomFieldStringName().$row->fieldID;
       array_push($_ARRAY,$field);
      }
	 return $_ARRAY;
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_ECOMMERCE_CATEGORY:
        {
         return wm3Ecommerce::addEcommerceCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_ECOMMERCE_CATEGORY:
        {
         $error = wm3Ecommerce::checkEcommerceCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Ecommerce::saveEcommerceCategory($w3);
           // $msg= message saved... //TODO
           return wm3Ecommerce::getEcommerceCategoryList($w3,$lastID);
          }
         else return wm3Ecommerce::addEcommerceCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_CATEGORY:
        {
         return wm3Ecommerce::editEcommerceCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_ECOMMERCE_CATEGORY:
        {
         $error = wm3Ecommerce::checkEcommerceCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Ecommerce::updateEcommerceCategory($w3);
           // $msg= message udated... //TODO
           return wm3Ecommerce::getEcommerceCategoryList($w3,$lastID);
          }
         else return wm3Ecommerce::editEcommerceCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_ECOMMERCE_CATEGORY:
        {
         wm3Ecommerce::disableEcommerceCategory($w3->getVariable('categoryID','get'));
         return wm3Ecommerce::getEcommerceCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_CATEGORY:
        {
         wm3Ecommerce::enableEcommerceCategory($w3->getVariable('categoryID','get'));
         return wm3Ecommerce::getEcommerceCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_CATEGORY:
        {
         wm3Ecommerce::deleteEcommerceCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Ecommerce::getEcommerceCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_ECOMMERCE_SUBCATEGORY:
        {
         return wm3Ecommerce::addEcommerceSubcategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_ECOMMERCE_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE");
         $error = wm3Ecommerce::checkEcommerceSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Ecommerce::saveEcommerceSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Ecommerce::getEcommerceSubcategoryList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Ecommerce::addEcommerceSubcategory($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_ECOMMERCE_SUBCATEGORY:
        {
         wm3Ecommerce::disableEcommerceSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Ecommerce::getEcommerceSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_SUBCATEGORY:
        {
         wm3Ecommerce::enableEcommerceSubcategory($w3->getVariable('subcategoryID','get'));
         return wm3Ecommerce::getEcommerceSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_SUBCATEGORY:
        {
         wm3Ecommerce::deleteEcommerceSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Ecommerce::getEcommerceSubcategoryList($w3);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_SUBCATEGORY:
        {
         return wm3Ecommerce::editEcommerceSubcategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_ECOMMERCE_SUBCATEGORY:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE");
         $error = wm3Ecommerce::checkEcommerceSubcategoryError($w3);
         if(!$error) {
                      $lastID = wm3Ecommerce::updateEcommerceSubcategory($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Ecommerce::getEcommerceSubcategoryList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Ecommerce::editEcommerceSubcategory($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_ADD_ECOMMERCE_PRODUCT:
        {
         return wm3Ecommerce::addEcommerceProduct($w3);
         break;
        }
       case WM3_cACTION_SAVE_ECOMMERCE_PRODUCT:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE");
         $error = wm3Ecommerce::checkEcommerceProductError($w3);
         if(!$error) {
                      $lastID = wm3Ecommerce::saveEcommerceProduct($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Ecommerce::getEcommerceProductList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Ecommerce::addEcommerceProduct($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_PRODUCT:
        {
		 wm3Ecommerce::synchronizeEcommerceProductCustomData($w3);
         return wm3Ecommerce::editEcommerceProduct($w3);
         break;
        }
       case WM3_cACTION_UPDATE_ECOMMERCE_PRODUCT:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE");
         $error = wm3Ecommerce::checkEcommerceProductError($w3);
         if(!$error) {
                      $lastID = wm3Ecommerce::updateEcommerceProduct($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Ecommerce::getEcommerceProductList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Ecommerce::editEcommerceProduct($w3,$error);
					 }
         break;
        }
       case WM3_cACTION_DISABLE_ECOMMERCE_PRODUCT:
        {
         wm3Ecommerce::disableEcommerceProduct($w3->getVariable('productID','get'));
         return wm3Ecommerce::getEcommerceProductList($w3,$w3->getVariable('productID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_PRODUCT:
        {
         wm3Ecommerce::enableEcommerceProduct($w3->getVariable('productID','get'));
         return wm3Ecommerce::getEcommerceProductList($w3,$w3->getVariable('productID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_PRODUCT:
        {
         wm3Ecommerce::deleteEcommerceProduct($w3->getVariable('productID','get'));
         return wm3Ecommerce::getEcommerceProductList($w3);
         break;
        }
       /*case WM3_cACTION_DUPLICATE_ECOMMERCE_PRODUCT:
        {
         $lastID = wm3Ecommerce::duplicateEcommerceProduct($w3);
         // $msg= message duplicated... //TODO
         return wm3Ecommerce::getEcommerceProductList($w3,$lastID);
         break;
        }*/
       case WM3_cACTION_ADD_ECOMMERCE_PICTURE:
        {
         return wm3Ecommerce::addEcommercePicture($w3);
         break;
        }
       case WM3_cACTION_SAVE_ECOMMERCE_PICTURE:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE");
         $error = wm3Ecommerce::checkEcommercePictureError($w3);
         if(!$error) {        	
                      $lastID = wm3Ecommerce::saveEcommercePicture($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Ecommerce::getEcommercePictureList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Ecommerce::addEcommercePicture($w3,$error);
				     }
         break;
        }
/*
       case WM3_cACTION_EDIT_ECOMMERCE_PICTURE:
        {
         return wm3Ecommerce::editEcommerceProduct($w3);
         break;
        }
       case WM3_cACTION_UPDATE_ECOMMERCE_PICTURE:
        {
         $error = wm3Ecommerce::checkEcommerceProductError($w3);
         if(!$error)
          {
           $lastID = wm3Ecommerce::updateEcommerceProduct($w3);
           // $msg= message udated... //TODO
           return wm3Ecommerce::getEcommerceProductList($w3,$lastID);
          }
         else return wm3Ecommerce::editEcommerceProduct($w3,$error);
         break;
        }*/
       case WM3_cACTION_DISABLE_ECOMMERCE_PICTURE:
        {
         wm3Ecommerce::disableEcommercePicture($w3->getVariable('pictureID','get'));
         return wm3Ecommerce::getEcommercePictureList($w3,$w3->getVariable('pictureID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_PICTURE:
        {
         wm3Ecommerce::enableEcommercePicture($w3->getVariable('pictureID','get'));
         return wm3Ecommerce::getEcommercePictureList($w3,$w3->getVariable('pictureID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_PICTURE:
        {
         wm3Ecommerce::deleteEcommercePicture($w3->getVariable('pictureID','get'));
         return wm3Ecommerce::getEcommercePictureList($w3);
         break;
        }
       case WM3_cACTION_ACCEPT_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::acceptEcommerceOrder($w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_REJECT_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::rejectEcommerceOrder($w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_SEND_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::sendEcommerceOrder($w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_WAIT_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::waitEcommerceOrder($w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3,$w3->getVariable('orderID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_ORDER:
        {
         wm3Ecommerce::deleteEcommerceOrder($w3->getVariable('orderID','get'));
         return wm3Ecommerce::getEcommerceOrderList($w3);
         break;
        }
       case WM3_cACTION_PRINTABLE_ECOMMERCE_ORDER:
        {
         return wm3Ecommerce::getEcommerceOrderItemList($w3,0,true,true);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM:
        {
         return wm3Ecommerce::getEcommerceOrderItemList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_ORDER:
        {
         return wm3Ecommerce::getEcommerceOrderList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_PICTURE:
        {
         return wm3Ecommerce::getEcommercePictureList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_PRODUCT:
        {
         return wm3Ecommerce::getEcommerceProductList($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY:
        {
         return wm3Ecommerce::getEcommerceSubcategoryList($w3);
         break;
        }
       default:
        {
         return wm3Ecommerce::getEcommerceCategoryList($w3);
        }
      }
    }

   public static function renderEcommerceCategoryList($w3,$currentID = 0,$admin = false,$no_icon = true,$no_allowed = true,$no_page_link = true,$folder_style = false,$no_header = true,$simple_counter = true)
    {
     // Get ecommerce category list for panel (home side)

     // Prepare variables to create the list
     //$query_filter = "WHERE enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME;
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  =  "&filter=$filter";
       //$query_filter .= " AND message LIKE '%$filter%'"; // ???
      }
     else { $search_link = ""; }
     $search_form_link  = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT;
     $id_link = "";
     if($w3->getAction() == WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY ||
        $w3->getAction() == WM3_cACTION_SHOW_ECOMMERCE_PRODUCT     ||
        $w3->getAction() == WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT)
      $show_subcategories = true;
     else $show_subcategories = false;

     require(WM3_cPATH_INCLUDE."panel_ecommerce_search_form.inc");

     if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
	  $search_form = "<br>".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>".$search_form;

     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin,$no_icon,$no_allowed,$base_link,$no_page_link,$show_subcategories,$folder_style,$no_header,$simple_counter,$search_form,true);
    }

   public static function renderEcommerceSubcategoryList($w3,$currentID = 0,$admin = false,$no_icon = true,$no_allowed = true,$no_page_link = true,$folder_style = false,$no_header = true,$simple_counter = true)
    {
     // Get ecommerce subcategory list for panel (home side)

     // Prepare variables to create the list
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME;

     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin,$no_icon,$no_allowed,$base_link,$no_page_link,$folder_style,$no_header,$simple_counter,true);
    }

   public static function renderEcommerceProductList($w3,$currentID = 0,$admin = false,$no_form_search = true,$show_picture = true,$special_offer = false)
    {
     // Get ecommerce product list for a subcategory (home side)

     // Prepare variables to create the list
     return wm3Ecommerce::getEcommerceProductList($w3,$w3->getVariable('productID','both'),$admin,$no_form_search,$show_picture,$special_offer);
    }

   public static function renderEcommerceSingleProduct($w3,$currentID = 0,$admin = false,$no_form_search = true,$error = 0,$info = false, $friend = false, $msg = '')
    {
     // Get single ecommerce product (home side)

     // Prepare variables
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subcategoryID','both');
     $productID     = $w3->getVariable('productID','both');
	 $pictureID     = $w3->getVariable('pictureID','both');
     //if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
     // $categoryID = wm3Ecommerce::getCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";

     $pageID = $w3->getVariable('pageID','both');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')";
     $columns = 1; $buttons = 0; 

     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.name DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'");

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     if(!$no_form_search) require(WM3_cPATH_INCLUDE."admin_download_search_form.inc");
     else                 $search_form = "";
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1664)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(501)."</a>");
     if($subcategoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) {
       	           array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
                   array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_ECOMMERCE_PRODUCT,"action_add.png","","",$w3->getWord(1665),0,16,16));
                  }
       else       {
       	           array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)."</a>");
				   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceProductName($w3,$productID)."</a>");
                  }
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);      

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create item
     $_CONTENTS = array(); $_WIDTHS = array();
	 $currency = $w3->getPreferences('ecommerce_currency');
     $row = mysql_fetch_object($rs);
	 if(!$row) return $str.wm3Section::makeNotFoundItem($w3,$columns,false);
     $link = $base_link.$id_link.$search_link.$extra_link;
     if($allowed) $allowed_link = $base_allowed_link."&productID=$row->productID";

     if($info) // More informations form
	  {
       $_STYLE = wm3Skin::getFormStyleArray(wm3Ecommerce::getEcommerceProductInformationFieldsArray());
       $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductInformationFieldsArray());
       switch($error)
        {
         case 1: // Empty name
          {
           $_STYLE['name']      = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(447);
           break;
          }
         case 2: // Bad email
          {
           $_STYLE['email']     = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(1151);
           break;
          }
         case 4: // Empty message
          {
           $_STYLE['message']   = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(132);
           break;
          }
         default:
          {
           // Default values for the form
		   $product_name = wm3Ecommerce::getEcommerceProductName($w3,$productID);
           $_FIELD['subject']      = $w3->getPreferences('site_address').": Information request for product '$product_name' (ID #$productID)";
		   $_FIELD['message_head'] = "Information request for product '$product_name' (ID #$productID)\nhttp://".$w3->getPreferences('site_address')."/$base_link$id_link$page_link&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\n\n";
		   $_FIELD['newsletter']   = WM3_cENABLED;
           $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
           $form_title = $w3->getWord(1616);
          }
        }
	   if(!$msg) require(WM3_cPATH_INCLUDE."home_ecommerce_information_form.inc");
       else      $home_content = "<b>$msg</b>";
      }
     if($friend) // Send to friend form
	  {
       $_STYLE = wm3Skin::getFormStyleArray(wm3Ecommerce::getEcommerceProductSendToFriendFieldsArray());
       $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductSendToFriendFieldsArray());
       switch($error)
        {
         /*case 1: // Empty name
          {//'friend_email'
           $_STYLE['name']      = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(367);//TODO...
           break;
          }*/
         case 1: // Friend email bad
          {
           $_STYLE['friend_email'] = WM3_cSKIN_ERROR;
           $_STYLE['formTitle']    = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(1151);
           break;
          }
         case 2: // Your email bad
          {
           $_STYLE['your_email'] = WM3_cSKIN_ERROR;
           $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(1151);
           break;
          }
         case 4: // Empty message
          {
           $_STYLE['message']   = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(367);//TODO...
           break;
          }
         default:
          {
           // Default values for the form
		   $product_name = wm3Ecommerce::getEcommerceProductName($w3,$productID);
           $_FIELD['subject']      = $w3->getPreferences('site_address').": Your friend send to you informations for product '$product_name'";
		   $_FIELD['message_head'] = "Your friend send to you information about this product: '$product_name'\nhttp://".$w3->getPreferences('site_address')."/$base_link$id_link$page_link&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\n\n";
		   $_FIELD['newsletter']   = WM3_cENABLED;
           $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
           $form_title = $w3->getWord(1617);
          }
        }
	   if(!$msg) require(WM3_cPATH_INCLUDE."home_ecommerce_send_to_friend_form.inc");
       else      $home_content = "<b>$msg</b>";
      }
	 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL) 
	  {
	   if(!$info && !$friend)
	    {
         $_STYLE = wm3Skin::getFormStyleArray(wm3Ecommerce::getEcommerceCartItemFieldsArray());
         $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceCartItemFieldsArray());
         switch($error)
          {
           case 1: // Bad quantity
            {
             $_STYLE['quantity']  = WM3_cSKIN_ERROR;
             $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
             $form_title = "Invalid quantity";//$w3->getWord(2);
             break;
            }
           default:
            {
             // Default values for the form
             //$_FIELD['categoryID'] = $w3->getVariable('categoryID','get'); // Take categoryID from get
             $_FIELD['quantity']  = 1;
             $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
             $form_title = $w3->getWord(693);
            }
          }
		 $product_options = wm3Ecommerce::selectEcommerceProductOptions($w3,$row->options);
	     require(WM3_cPATH_INCLUDE."home_ecommerce_cart_add_form.inc");
		}

       $availability_content = "";
       if(!$info && !$friend)
	    {
	     $availability = $w3->getWord(676)." ".$w3->getWord(678+$row->availability);
	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_HEIGHT)  $availability .= wm3Util::renderImg('misc_availability_height.png', '',24,24);
	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_EVERAGE) $availability .= wm3Util::renderImg('misc_availability_average.png','',24,24);
	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_LOW)     $availability .= wm3Util::renderImg('misc_availability_low.png',    '',24,24);
  	     if($row->availability == WM3_cECOMMERCE_AVAILABILITY_NONE)    $availability .= wm3Util::renderImg('misc_availability_none.png',   '',24,24);
         $availability_content = $availability;
	     $availability_content .= "<br><br>$home_content";
	    }
      }
	 else { $availability_content = ""; }

	 if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178)); else $button = "";
	 if($row->discount > 0) $price = "<s>$row->price $currency $row->price_description</s><br>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description <i>(".$w3->getWord(1500)." $row->discount %)</i>";
	 else                   $price = "$row->price $currency $row->price_description";

     $extra_fields = $extra_button = "";
	 if($w3->getPreferences('ecommerce_show_extra') == WM3_cENABLED)
	  {
	   // Printable, more informations and send to friend buttons
	   $extra_button  = wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_PRINTABLE_SINGLE_ECOMMERCE_PRODUCT,"action_print_mini.png","","",$w3->getWord(1400),0,16,16,'absmiddle','_blank');
	   $extra_button .= " $_SEP ".wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_INFORMATIONS_SINGLE_ECOMMERCE_PRODUCT,"action_add.png","","",$w3->getWord(1487),0,16,16);
       $extra_button .= " $_SEP ".wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_SEND_TO_FRIEND_SINGLE_ECOMMERCE_PRODUCT,"action_newsletter.png","","",$w3->getWord(1488),0,16,16);
	   if($info || $friend) $extra_button .= " $_SEP ".wm3Util::actionButton($base_link.$id_link."&productID=$productID&pictureID=$pictureID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT,"action_down.png","","",$w3->getWord(-1)."Return to product",0,16,16);
	   $extra_button .= "<br><br>";
      }
	 if(!$info && !$friend) $extra_fields = wm3Ecommerce::renderEcommerceProductCustomFieldData($w3,$productID,false);
	 $pictures_list = wm3Ecommerce::getEcommercePictureList($w3,0,false);

     $code = $picture_content = $price_content = "";
	 if(!$info && !$friend)
	  {
	   $picture_content = wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$productID,$pictureID,false,-1);
       if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)   { $code = " ($row->code)"; $price_content = $price; }
	   else if($w3->getPreferences('ecommerce_show_catalogue_price') == WM3_cENABLED) { $code = " ($row->code)"; $price_content = $price; }
       $title_content       = "<b>$row->name</b>$code $button<br><br>$row->description";
	   $description_content = "<br>$extra_button$extra_fields<br><i>".wm3Util::renderContent($w3,$row->full_description,$row->render_mode)."</i><br><br>$pictures_list";
      }
	 else
	  {
	   $title_content       = "<br>$extra_button";
	   $description_content = $home_content;
	  }
     ob_start();
     require($w3->getSkinObj()->getFrameProduct($picture_content));
     $item_content = ob_get_contents();
     ob_end_clean();
     array_push($_CONTENTS,$item_content); array_push($_WIDTHS,100);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

     // Create list bottom
     if($total_items > 1) $bottom_content = wm3Util::makePagesNavigator(0,0,0,$base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_MEDIA,$rs_aux,"productID",$row->productID);
	 else $bottom_content = "";
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function renderEcommerceSingleProductPrintable($w3)
    {
     // Get single printable ecommerce product (home side)

     // Prepare variables
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subcategoryID','both');
     $productID     = $w3->getVariable('productID','both');
	 $pictureID     = $w3->getVariable('pictureID','both');
     //if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
     // $categoryID = wm3Ecommerce::getCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'"; else $query_filter = "";
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')";
     $columns = 1; $buttons = 0;

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.name DESC"); // Do the query without "limit"
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query." AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID = '$productID'");

     if($subcategoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       $title = wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID);
       $title .= " $_PSEP ".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID);
       $title .= " $_PSEP ".wm3Ecommerce::getEcommerceProductName($w3,$productID);
      }

     // Create list header
     $_CONTENTS = array();
     $content = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,"");      

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create item
     $_CONTENTS = array(); $_WIDTHS = array();
	 $currency = $w3->getPreferences('ecommerce_currency');
     $row = mysql_fetch_object($rs);
	 if(!$row) return $str.wm3Section::makeNotFoundItem($w3,$columns,false);

	 if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL) 
	  {
       $availability_content = "";
       $availability = $w3->getWord(676)." ".$w3->getWord(678+$row->availability);
	   if($row->availability == WM3_cECOMMERCE_AVAILABILITY_HEIGHT)  $availability .= wm3Util::renderImg('misc_availability_height.png', '',24,24);
	   if($row->availability == WM3_cECOMMERCE_AVAILABILITY_EVERAGE) $availability .= wm3Util::renderImg('misc_availability_average.png','',24,24);
	   if($row->availability == WM3_cECOMMERCE_AVAILABILITY_LOW)     $availability .= wm3Util::renderImg('misc_availability_low.png',    '',24,24);
  	   if($row->availability == WM3_cECOMMERCE_AVAILABILITY_NONE)    $availability .= wm3Util::renderImg('misc_availability_none.png',   '',24,24);
       $availability_content = $availability;
      }
	 else { $availability_content = ""; }

	 if($row->discount > 0) $price = "<s>$row->price $currency $row->price_description</s><br><b>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description</b> <i>(".$w3->getWord(1500)." $row->discount %)</i>";
	 else                   $price = "<b>$row->price $currency $row->price_description</b>";

     $extra_fields = $extra_button = "";
     $extra_fields = wm3Ecommerce::renderEcommerceProductCustomFieldData($w3,$productID,false);

     $code = $picture_content = $price_content = "";
     $picture_content = wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$productID,$pictureID,false,-1);
     if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)   { $code = " ($row->code)"; $price_content = $price; }
	 else if($w3->getPreferences('ecommerce_show_catalogue_price') == WM3_cENABLED) { $code = " ($row->code)"; $price_content = $price; }
     $title_content       = "<b>$row->name</b>$code<br><br>$row->description<br>$price_content<br><br>$availability_content";
	 $description_content = "<br>$extra_fields<br><i>".wm3Util::renderContent($w3,$row->full_description,$row->render_mode)."</i>";
	 
	 $_CONTENTS = array(); $_WIDTHS = array();
     if($picture_content) { array_push($_CONTENTS,$picture_content); array_push($_WIDTHS,0); }
	 array_push($_CONTENTS,$title_content); array_push($_WIDTHS,100);
     $content .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

	 $_CONTENTS = array(); $_WIDTHS = array();
	 array_push($_CONTENTS,$description_content); array_push($_WIDTHS,100);
     if($picture_content) $content .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(2));
	 else                 $content .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

     // Create list bottom
     $content .= wm3Section::makeBottomList($w3,$columns,"");

	 $w3->getPageObj()->setTitle($title);
	 $w3->getPageObj()->setSubTitle('');
	 $w3->getPageObj()->setPageContent($content);
    }

   public static function renderEcommerceProductCustomFieldData($w3,$productID = 0,$admin = false)
    {
     // Get single ecommerce product custom fields data list (home side)

     // Prepare variables
     if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL)
      $query_filter = "AND (show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_TRANSACTIONS." OR show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_BOTH.")";
     else
	  $query_filter = "AND (show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_CATALOGUE." OR show_in = ".WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_BOTH.")";
	 $columns = 2; $buttons = 0; 

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.fieldID DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.*,
	                  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.show_in
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data,
			          ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.productID='$productID' AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.enabled='".WM3_cENABLED."'
			     AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data.fieldID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.fieldID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by);
	 $rs_aux = $rs;
     $total_items = mysql_num_rows($rs);
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query);

     // Create list header
     $_CONTENTS = array();
     if($admin) array_push($_CONTENTS,$w3->getWord(1664));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,"");

     // Create list caption

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return "";

     // Create item
     $p = 1;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
	   array_push($_WIDTHS,20,80);
       $label = wm3Ecommerce::getEcommerceProductCustomFieldLabel($w3,$row->fieldID);
       $value = $row->value;
       array_push($_CONTENTS,$label,$value);
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
	   $p++;
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns,"");

     return $str;
    }

   public static function getEcommerceCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function checkEcommerceCategoryError($w3)
    {
     return $w3->getSectionObj()->checkCategoryError($w3);
    }

   public static function addEcommerceCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editEcommerceCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function saveEcommerceCategory($w3)
    {
     return $w3->getSectionObj()->saveCategory($w3);
    }

   public static function updateEcommerceCategory($w3)
    {
     return $w3->getSectionObj()->updateCategory($w3);
    }

   public static function disableEcommerceCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableEcommerceCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteEcommerceCategory($w3,$categoryID)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data       WRITE");

     // Delete also the images, cart items (no ordered) and custom data
     $rs = wm3Sql::sqlQuery("SELECT productID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
							        ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
	                                ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID = '$categoryID'
							   AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID
							   AND  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID");
     while($row = mysql_fetch_object($rs))
	  {
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE productID = '$row->productID'");
       wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE productID = '$row->productID' AND orderID = '0'");
       wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data WHERE productID = '$row->productID'");
      }

     $w3->getSectionObj()->deleteCategory($categoryID);
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function selectEcommerceCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
    }

   public static function getEcommerceCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($categoryID);
    }

   public static function getEcommerceSubcategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin);
    }

   public static function checkEcommerceSubcategoryError($w3)
    {
     return $w3->getSectionObj()->checkSubcategoryError($w3);
    }

   public static function addEcommerceSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addSubcategory($w3,$error);
    }

   public static function editEcommerceSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editSubcategory($w3,$error);
    }

   public static function saveEcommerceSubcategory($w3)
    {
     return $w3->getSectionObj()->saveSubcategory($w3);
    }

   public static function updateEcommerceSubcategory($w3)
    {
     return $w3->getSectionObj()->updateSubcategory($w3);
    }

   public static function disableEcommerceSubcategory($subcategoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories SET enabled = '".WM3_cDISABLED."' WHERE subcategoryID = '$subcategoryID'");
    }

   public static function enableEcommerceSubcategory($subcategoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories SET enabled = '".WM3_cENABLED."' WHERE subcategoryID = '$subcategoryID'");
    }
   
   public static function deleteEcommerceSubcategory($w3,$subcategoryID)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data       WRITE");

     // Delete also the images, cart items (no ordered) and custom data
     $rs = wm3Sql::sqlQuery("SELECT productID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  subcategoryID = '$subcategoryID'");
     while($row = mysql_fetch_object($rs))
	  {
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE productID = '$row->productID'");
       wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE productID = '$row->productID' AND orderID = '0'");
       wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data WHERE productID = '$row->productID'");
      }

     $w3->getSectionObj()->deleteSubcategory($subcategoryID);
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function getEcommerceSubcategoryName($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getSubcategoryName($subcategoryID);
    }

   public static function selectEcommerceSubcategory($w3,$name,$subcategoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$name,$subcategoryID,$all,$admin);
    }

   public static function getEcommerceCategoryID($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getCategoryID($subcategoryID);
    }

   public static function getEcommerceSubcategoryID($w3,$productID)
    {
     // Get subcategoryID from a productID
     $rs = wm3Sql::sqlQuery("SELECT subcategoryID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  productID = '$productID'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->subcategoryID;
    }

   public static function getEcommerceProductList($w3,$currentID = 0,$admin = true,$no_form_search = false,$show_picture = false,$special_offer = false)
    {
     // Get products list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subcategoryID','both');
	 $currency = $w3->getPreferences('ecommerce_currency');
     if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
      $categoryID = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);	  
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     if($special_offer) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.special = '".WM3_cENABLED."'"; // Show special offer only
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.description LIKE '%$filter%'";
     	         }
     else        { if(!$special_offer) { if(!$subcategoryID) $query_filter =" AND 1=0"; } $search_link = ""; }
     if($admin) {
                 $width_name        = 30;
                 $width_description = 40;
                 $search_form_link  = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 7; $buttons = 4;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link         = "&pageID=$pageID";
                 $search_form_link  = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."$page_link";
                 $base_link         = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_name        = 35;
                 $width_description = 65;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')";
     	         if($allowed) { $columns = 3; $buttons = 1; } else { $columns = 2; $buttons = 0; }
     	         if($show_picture) { $width_name = 0; $width_description = 100; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
	 $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.description DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'productID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     if(!$no_form_search) require(WM3_cPATH_INCLUDE."admin_download_search_form.inc");
     else                 $search_form = "";
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1664)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(501)."</a>");
     if($subcategoryID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) {
       	           array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
                   array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_ECOMMERCE_PRODUCT,"action_add.png","","",$w3->getWord(1665),0,16,16));
                  }
       else       {
       	           array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
                  }
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);      

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_name,$width_description,30,0),array(194,1671,1407),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
	   if($row->discount > 0) $price = "<s>$row->price $currency $row->price_description</s><br>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description <i>(".$w3->getWord(1500)." $row->discount %)</i>";
  	   else                   $price = "$row->price $currency";
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&productID=$row->productID";
       if($allowed) $allowed_link = $base_allowed_link."&productID=$row->productID";
       if($subcategoryID || $special_offer)
	                      {
                           if($admin) {
							           $total_pictures = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures","WHERE productID='$row->productID'");
                           	           array_push($_CONTENTS,"<a href=\"$link&action=".WM3_cACTION_SHOW_ECOMMERCE_PICTURE."\">$row->name</a><br>($total_pictures pictures)");
                        	           array_push($_CONTENTS,"$price<br>".$row->description);
                        	          }
                           else       {
							           $price_content = "";
							           if($w3->getPreferences('ecommerce_type') == WM3_cPREFERENCES_ECOMMERCE_FULL) $price_content = $price."<br>";
	                                   else if($w3->getPreferences('ecommerce_show_catalogue_price') == WM3_cENABLED) $price_content = $price."<br>";
                           	           if($show_picture)
                           	            {
										 $picture = wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$row->productID);
									 	 if($special_offer)
    									  $link = $base_link."&subcategoryID=".$row->subcategoryID."&categoryID=".wm3Ecommerce::getEcommerceCategoryID($w3,$row->subcategoryID).$extra_link."&productID=$row->productID";
                           	             array_push($_CONTENTS,"<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$picture</a>");
                           	             array_push($_CONTENTS,"<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$row->name</a><br>$price_content".$row->description);
                           	            }
                           	           else
                           	            {
                           	             array_push($_CONTENTS,"<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$row->name</a>");
                        	             array_push($_CONTENTS,"$price_content".$row->description);
                        	            }
                        	          }
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           array_push($_CONTENTS,"$row->name<br>(".$w3->getWord(659)."
                           	                      <a href=\"$base_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$row->subcategoryID)."</a>)");
                                       array_push($_CONTENTS,$row->description);
									  }
                           else       {
							           if($show_picture) array_push($_CONTENTS,"<a href=\"$link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$row->productID)."</a>");
                           	           array_push($_CONTENTS,"<a href=$link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT.">$row->name</a><br>(".$w3->getWord(659)."
                           	                      <a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($row->subcategoryID)."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$w3->getSectionObj()->getCategoryID($row->subcategoryID))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$row->subcategoryID)."</a>)");
                                       array_push($_CONTENTS,$row->description);
									  }
                          }
       array_push($_WIDTHS,$width_name,$width_description);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag); array_push($_WIDTHS,30);
         // Buttons
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_ECOMMERCE_PICTURE,"action_add_from.png",$w3->getWord(1667)));
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_ECOMMERCE_PRODUCT,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_ECOMMERCE_PRODUCT,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_PRODUCT,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->productID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT.$id_link.$search_link);
       else       if($special_offer) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SPECIAL_OFFER.$id_link.$search_link);
	              else               $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function getEcommercePictureList($w3,$currentID = 0,$admin = true)
    {
     // Get product pictures list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
	 $use_colors = false;
	 if($admin) $items_per_row = 1; else $items_per_row = 4;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_ECOMMERCE); // Used to enable admin buttons in home stage
     $productID     = $w3->getVariable('productID','both');
     $categoryID    = $w3->getVariable('categoryID','both');
     $subcategoryID = $w3->getVariable('subcategoryID','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($admin) {
                 $width_thumbnail   = 0;
                 $width_description = 70;
				 $query_filter = "";
                 $search_form_link  = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 5; $buttons = 2;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link         = "&pageID=$pageID";
                 $search_form_link  = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."$page_link";
                 $base_link         = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_thumbnail   = 0;
                 $width_description = 100;
				 $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".WM3_cLANGUAGE_ALL."')";
     	         if($allowed) { $columns = 2; $buttons = 0; } else { $columns = 2; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$productID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.ts DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID = '$productID'
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'pictureID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     if($admin) {
		         require(WM3_cPATH_INCLUDE."admin_download_search_form.inc");
                 array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(1664)."</a>");
                }
     else       {
		         array_push($_CONTENTS,$w3->getWord(1749));
	             $search_form = "";
				}
     if($productID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
       $_PSEP = $w3->getSkinObj()->getPathSeparator();	
       if($admin) {
                   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_SUBCATEGORY."\">".wm3Ecommerce::getEcommerceCategoryName($w3,$categoryID)."</a>");
                   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommerceSubcategoryName($w3,$subcategoryID)."</a>");
                   array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PICTURE."\">".wm3Ecommerce::getEcommerceProductName($w3,$productID)." ($total_items)</a>");
                   array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_ECOMMERCE_PICTURE,"action_add.png","","",$w3->getWord(1667),0,16,16));
                  }
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);      

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_thumbnail,$width_description,30,0),array(194,1671,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
	 $_CONTENTS = array(); $_WIDTHS = array();
     while($row = mysql_fetch_object($rs))
      {
	   $link = $base_link.$id_link.$extra_link."&pictureID=$row->pictureID";
       if($allowed) $allowed_link = $base_allowed_link."&productID=$row->productID";       
       if($subcategoryID) {
                           if($admin) {
							           array_push($_CONTENTS,"<a href=\"".WM3_cPATH_ECOMMERCE."$row->picture\" target=\"_blank\"><img src=\"".WM3_cPATH_ECOMMERCE."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>");
                        	           array_push($_CONTENTS,$row->description);
									  }
                           else       {
                           	           $picture_content = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\"><img src=\"".WM3_cPATH_ECOMMERCE."$row->thumbnail\" width=\"120\" height=\"90\" border=\"0\" alt=\"$row->description\" title=\"$row->description\"></a>";
                                       $title_content   = "";//<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->description</a>";
                                       ob_start();
                                       require($w3->getSkinObj()->getFramePicture());
                                       $item_content = ob_get_contents();
                                       ob_end_clean();
                           	           array_push($_CONTENTS,$item_content);
									  }
                          }
       if($admin)
        {
		 array_push($_WIDTHS,$width_thumbnail,$width_description);
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$lang_flag); array_push($_WIDTHS,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_ECOMMERCE_PICTURE,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_ECOMMERCE_PICTURE,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_ECOMMERCE_PICTURE,"action_delete.png",$w3->getWord(179),$w3->getWord(772)));
        }
       else
        {
		 array_push($_WIDTHS,25);
         //if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PICTURE,"action_edit.png",$w3->getWord(178)));
        }
       $aux = ($p+1)%$items_per_row;
       if($aux == 0 || ($p+1+$pg*12) == $total_items)
        {
         if($admin) { $c = $p; $test = $row->productID==$currentID; } else { if($use_colors) $c = $p; else $c = 0; $test = false; }
         if($aux != 0) // Incomplete row 
          for($i = $aux; $i < $items_per_row; $i++) 
           array_push($_CONTENTS,"");
         $str .= wm3Section::makeItemList($w3,$c,$_WIDTHS,$_CONTENTS,$test);
         $_CONTENTS = array(); $_WIDTHS = array();
        }
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PICTURE.$id_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_PICTURE.$id_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function getEcommerceProductCustomField($w3,$error = 0,$admin = true,$from_db = false)
    {
     // Get ecommerce custom fields list to add/edit a product (admin side)

     // Prepare variables
     $query_filter = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.fieldID DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.enabled='".WM3_cENABLED."'
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by);
     $total_items = mysql_num_rows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return '';

     // Create list header
	 if($admin) $str = wm3Section::makeFormSeparator($w3,2,$w3->getWord(1572));

     // Create list items
     $p = 0;
	 $_STYLE = wm3Skin::getFormStyleArray(array('even','odd'));

     if($from_db) // Take values from database
      {
       $rs_db = wm3Sql::sqlQuery("SELECT fieldID,value FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                                  WHERE productID = '".$w3->getVariable('productID','get')."'
								  ORDER BY fieldID DESC");
       while($row_db = mysql_fetch_object($rs_db))
        $_FIELD[wm3Ecommerce::getCustomFieldStringName().$row_db->fieldID] = $row_db->value;
      }
     else // Take values from post
	  {
	   $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomFieldValueArray());
      }

	 $_NAME  = array_keys($_FIELD);
     while($row = mysql_fetch_object($rs))
      {
	   if($p%2 == 0) $style = $_STYLE['odd']; else $style = $_STYLE['even'];
	   if($row->fieldID == $error - 100) $style = WM3_cSKIN_ERROR;
	   $label = wm3Ecommerce::getEcommerceProductCustomFieldLabel($w3,$row->fieldID,true);
       $str .=  wm3Section::makeFormItem($w3,$style,$label,wm3Util::inputText($_NAME[$p],$_FIELD[$_NAME[$p]],$row->size));
	   $p++;
      }

     return $str;
    }

   public static function getEcommerceOrderList($w3,$currentID = 0,$admin = true)
    {
     // Get orders list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($admin)
      {
       $width_order  = 30;
	   $width_user   = 15;
       $width_info   = 35;
	   $width_status = 20;
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE;
       $columns = 9; $buttons = 5;
      }
     else
      {
       $width_order  = 35;
       $width_info   = 40;
	   $width_status = 25;
       if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
       $query_filter .= "userID='".$w3->getAuthenticateUserID()."'";
       //if($allowed) { $columns = 4; $buttons = 1; } else 
	   { $columns = 3; $buttons = 0; }
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders.order_ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'orderID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
	 if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_message_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(794)." ($total_items)");
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_order,$width_user,$width_info,$width_status,0),array(750,403,1671,806),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link."&orderID=$row->orderID";
       //if($allowed) $allowed_link = $base_allowed_link."&orderID=$row->orderID";
	   $order  = "<a href=\"$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM."\">Order id: #$row->orderID</a><br>Order date: ".wm3Util::renderDate($w3,$row->order_ts,$w3->getAdminLanguage());
	   if($admin) $user = wm3User::getUserLogin($row->userID);
	   $total = wm3Ecommerce::getEcommerceOrderTotal($w3,$row->orderID);
       $info   = "Total: $total currency...<br>(xx items)";
       if($row->status == WM3_cECOMMERCE_ORDER_WAITING) $status = "<img src=\"".WM3_cPATH_DATA."action_order_wait.png\"   width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(745);
	   if($row->status == WM3_cECOMMERCE_ORDER_ACCEPT)  $status = "<img src=\"".WM3_cPATH_DATA."action_order_accept.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(744);
	   if($row->status == WM3_cECOMMERCE_ORDER_SENDED)  $status = "<img src=\"".WM3_cPATH_DATA."action_order_send.png\"   width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(743);
	   if($row->status == WM3_cECOMMERCE_ORDER_REJECT)  $status = "<img src=\"".WM3_cPATH_DATA."action_order_reject.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(746);
       if($admin)
        {
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 array_push($_CONTENTS,$order,$user,$info,$status); array_push($_WIDTHS,$width_order,$width_user,$width_info,$width_status);
         // Buttons
		 $button_accept          = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ACCEPT_ECOMMERCE_ORDER,"action_order_accept.png",$w3->getWord(719),$w3->getWord(767));
		 $button_accept_inactive = wm3Util::renderImg('action_order_accept_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_reject          = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_REJECT_ECOMMERCE_ORDER,"action_order_reject.png",$w3->getWord(720),$w3->getWord(768));
		 $button_reject_inactive = wm3Util::renderImg('action_order_reject_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_send            = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SEND_ECOMMERCE_ORDER,"action_order_send.png",$w3->getWord(721),$w3->getWord(769));
		 $button_send_inactive   = wm3Util::renderImg('action_order_send_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_wait            = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_WAIT_ECOMMERCE_ORDER,"action_order_wait.png",$w3->getWord(721),$w3->getWord(769));
		 $button_wait_inactive   = wm3Util::renderImg('action_order_wait_inactive.png','',24,24,WM3_cPATH_DATA);
		 $button_delete          = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_ORDER,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
		 $button_delete_inactive = wm3Util::renderImg('action_delete_inactive.png','',24,24,WM3_cPATH_DATA);
		 if($row->status == WM3_cECOMMERCE_ORDER_WAITING)
          array_push($_CONTENTS,$button_accept,$button_reject,$button_send_inactive,$button_wait_inactive,$button_delete);
		 if($row->status == WM3_cECOMMERCE_ORDER_ACCEPT)
          array_push($_CONTENTS,$button_accept_inactive,$button_reject_inactive,$button_send,$button_wait,$button_delete_inactive);
		 if($row->status == WM3_cECOMMERCE_ORDER_REJECT)
          array_push($_CONTENTS,$button_accept_inactive,$button_reject_inactive,$button_send_inactive,$button_wait,$button_delete);
		 if($row->status == WM3_cECOMMERCE_ORDER_SENDED)
          array_push($_CONTENTS,$button_accept_inactive,$button_reject_inactive,$button_send_inactive,$button_wait_inactive,$button_delete_inactive);
        }
       else
        {
         array_push($_CONTENTS,$order,$info,$status); array_push($_WIDTHS,$width_order,$width_info,$width_status);
         //if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->orderID==$currentID);
       $p++;
      }
     if(!$admin)
	  {
       $_CONTENTS = array();
       array_push($_CONTENTS,"<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>");
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false,array(3));
	  }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER.$id_link);
       else       $bottom_content = '';
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function getEcommerceOrderItemList($w3,$currentID = 0,$admin = true,$printable = false)
    {
     // Get items list for an order (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     //$allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
	 $orderID = $w3->getVariable('orderID','both');
     $pg = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "AND message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($admin)
      {
       $width_product  = 60;
	   $width_quantity = 8;
       $width_price    = 8;
	   $width_data     = 24;
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE;
       if($printable) { $columns = 4; $buttons = 0; }
	   else           { $columns = 5; $buttons = 1; }
      }
     else
      {
       $width_product  = 60;
	   $width_quantity = 8;
       $width_price    = 8;
	   $width_data     = 24;
       $query_filter .= "AND userID='".$w3->getAuthenticateUserID()."'";
       //if($allowed) { $columns = 4; $buttons = 1; } else
	   { $columns = 3; $buttons = 0; }
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	           WHERE  orderID = '$orderID'
                      $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'orderID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
	 if($printable) $limit = "";
	 else           $limit = " LIMIT ".($pg*$max_page_items).",$max_page_items";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by.$limit);

     // Create list header
     $_CONTENTS = array(); $search_form = "";
	 $_SEP = $w3->getSkinObj()->getSeparator();
     if($admin)
      {
	   if(!$printable)
	    {
	     $_PSEP = $w3->getSkinObj()->getPathSeparator();
	     $button_accept  = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_ACCEPT_ECOMMERCE_ORDER,"action_order_accept.png",'',$w3->getWord(767),$w3->getWord(719));
	     $button_reject  = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_REJECT_ECOMMERCE_ORDER,"action_order_reject.png",'',$w3->getWord(768),$w3->getWord(720));
	     $button_send    = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_SEND_ECOMMERCE_ORDER,"action_order_send.png",    '',$w3->getWord(769),$w3->getWord(721));
	     $button_wait    = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_WAIT_ECOMMERCE_ORDER,"action_order_wait.png",    '',$w3->getWord(769),$w3->getWord(721));
	     $button_delete  = wm3Util::actionButton("$base_link&orderID=$orderID&action=".WM3_cACTION_DELETE_ECOMMERCE_ORDER,"action_delete.png",      '',$w3->getWord(774),$w3->getWord(179));
         $status_buttons = "";
	     $order_status   = wm3Ecommerce::getEcommerceOrderStatus($orderID);
	     if($order_status == WM3_cECOMMERCE_ORDER_WAITING)
	      {
	       $status = "<img src=\"".WM3_cPATH_DATA."action_order_wait.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(745);
	       $status_buttons = " $_SEP $button_accept $_SEP $button_reject $_SEP $button_delete";
	      }
	     if($order_status == WM3_cECOMMERCE_ORDER_ACCEPT)
	      {
		   $status = "<img src=\"".WM3_cPATH_DATA."action_order_accept.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(744);
	       $status_buttons = " $_SEP $button_send $_SEP $button_wait";
	      }
	     if($order_status == WM3_cECOMMERCE_ORDER_REJECT)
	      {
           $status = "<img src=\"".WM3_cPATH_DATA."action_order_reject.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(746);
	       $status_buttons = " $_SEP $button_wait $_SEP $button_delete";
	      }
	     if($order_status == WM3_cECOMMERCE_ORDER_SENDED)
	      {
		   $status_buttons = "";
	       $status = "<img src=\"".WM3_cPATH_DATA."action_order_send.png\" width=\"24\" height=\"24\" align=\"absmiddle\"> ".$w3->getWord(743);
	      }
	     $status_buttons .= " $_SEP ".wm3Util::actionButton($base_link.$extra_link."&orderID=$orderID&action=".WM3_cACTION_PRINTABLE_ECOMMERCE_ORDER,"action_print.png",'','',$w3->getWord(1400),0,24,24,"absmiddle","_blank");
	     $user_name = "username TODO";//wm3User::getUserLogin($row->userID);
	     $total = wm3Ecommerce::getEcommerceOrderTotal($w3,$orderID);
         require(WM3_cPATH_INCLUDE."admin_message_search_form.inc");
         array_push($_CONTENTS,"<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_ECOMMERCE."&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER."\">".$w3->getWord(794)."</a> ".$_PSEP." Order id: #$orderID ($total_items, $total ".$w3->getPreferences('ecommerce_currency').", $user_name, $status) $status_buttons");
		}
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Order user information     
	 $userID = wm3Ecommerce::getEcommerceOrderUserID($orderID);
	 if($userID)
	  {
	   $str .= wm3Section::makeCaptionList($w3,array($width_product,$width_quantity,$width_price,$width_data,0),array(398,-1,-1,-1),$buttons);
       $user_rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users WHERE userID = '$userID'");
       if(mysql_num_rows($user_rs) == 0) $user_info = "User not found.";
	   $row = mysql_fetch_object($user_rs);
	   $user_info = "$row->name $row->surname ($row->login)<br>$row->address<br>$row->zip_code $row->city ($row->stateID), ".wm3Statistic::getCountryName($w3,$row->countryID);
       $str .= wm3Section::makeItemList($w3,1,array(100),array($user_info),false,array($columns));
      }

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array($width_product,$width_quantity,$width_price,$width_data,0),array(737,677,674,807),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&orderID=$row->orderID";
       //if($allowed) $allowed_link = $base_allowed_link."&orderID=$row->orderID";
	   $product_link = "";
       if(!$printable)
	    {
	     if(wm3Ecommerce::existsEcommerceProduct($row->productID))
		  {
		   if($admin) $product_link = " ".wm3Util::actionButton("$link&productID=$row->productID&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_show.png",'','','Show product',0,16,16);
		   else       {
                       $subcategoryID = wm3Ecommerce::getEcommerceSubcategoryID($w3,$row->productID);
                       $categoryID    = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);
			           $product_link = " ".wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT,"action_show.png",'','','Show product',0,16,16);
				      }
	      }
	     else         $product_link = " <i>(Product was deleted)</i>";
	    }
	   $product  = "<b>$row->product_name</b> (#$row->product_code)$product_link<br>$row->product_description";
	   $quantity = $row->quantity;
       $price    = $row->price;
       $data     = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       if($admin)
        {
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 array_push($_CONTENTS,$product,$quantity,$price,$data); array_push($_WIDTHS,$width_product,$width_quantity,$width_price,$width_data);
         // Buttons
		 if(!$printable) array_push($_CONTENTS,$button_delete = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_ORDER,"action_delete.png",$w3->getWord(179),$w3->getWord(774)));
        }
       else
        {
         //array_push($_CONTENTS,$order,$info,$status); array_push($_WIDTHS,$width_product,$width_price,$width_data);
		 array_push($_CONTENTS,$product,$quantity,$price,$data); array_push($_WIDTHS,$width_product,$width_quantity,$width_price,$width_data);
         //if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->orderID==$currentID);
       $p++;
      }
     if(!$admin)
	  {
       $_CONTENTS = array();
       array_push($_CONTENTS,"<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>");
	   $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false,array(3));
	  }

     // Create list bottom
	 //$str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,array($total),false); //TODO totale???
     $bottom_content = "";
	 if(!$printable)
	  {
       if($total_items > $max_page_items)
        {
         if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&orderID=$orderID&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER_ITEM.$id_link);
         else       $bottom_content = '';
        }
	  }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     // Set correct title and subtitle
     if($printable) {
		             $w3->getPageObj()->setTitle("Order id: #$orderID");
					 $w3->getPageObj()->setSubTitle("&nbsp;");
				    }

     return $str;
    }

   public static function checkEcommerceProductError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray());
	 if(!$w3->getSectionObj()->existsSubcategory($_FIELD['subcategoryID'])) return 1;
     if($_FIELD['code']=='') return 2;
     if($_FIELD['name']=='') return 3;

	 // Check custom fields errors
	 $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomFieldValueArray());
	 $_ID    = array_keys($_FIELD);
	 for($i = 0; $i < sizeof($_FIELD); $i++)
	  {
	   $fieldID = substr($_ID[$i],wm3Ecommerce::getCustomFieldStringName(true));
	   $value   = $_FIELD[$_ID[$i]];
       if(wm3Ecommerce::checkEcommerceCustomFieldError($fieldID,$value)) return 100 + $fieldID;
      }
     return 0;
    }

   public static function checkEcommerceCustomFieldError($fieldID,$value)
    {
     // Check form invalid inputs
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                             WHERE fieldID = '$fieldID'");
     $row = mysql_fetch_object($rs);

     if($value=='' && $row->required == WM3_cENABLED) return true;

     if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_INTEGER)
	  if(!wm3Util::isInteger($value)) return true;

	 if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_DECIMAL)
	  if(!wm3Util::isInteger($value)) return true;

	 //if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_STRING)$row->size;

     return false;
    }

   public static function checkEcommercePictureError($w3)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommercePictureFieldsArray());

     $aux = time()."_".rand(1,99999); // Avoid overwritting the files
     if($_FIELD['picture_from'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['picture_from_local']['name']) $picture_name = $aux.".".wm3Util::cutExtension($_FILES['picture_from_local']['name']);
       else                                      $picture_name = "";
       $error = wm3Folder::uploadFile("picture_from_local",WM3_cPATH_ECOMMERCE,$picture_name,true,wm3Folder::mimeTypeImage(),0);
       if($error) return $error;
      }
     if($_FIELD['thumbnail_from'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['thumbnail_from_local']['name']) $thumbnail_name = $aux."_t.".wm3Util::cutExtension($_FILES['thumbnail_from_local']['name']);
       else                                        $thumbnail_name = "";
       $error = wm3Folder::uploadFile("thumbnail_from_local",WM3_cPATH_ECOMMERCE,$thumbnail_name,true,wm3Folder::mimeTypeImage(),0);
       if($error) return $error + 6;
      }
	 if(!wm3Ecommerce::existsEcommerceProduct($_FIELD['productID'])) return 13;
     return 0; // Take file from remote folder (or no errors)
    }

   public static function addEcommerceProduct($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Ecommerce::getEcommerceProductFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray());
     // Fields for paging default value
	 $custom_fields = wm3Ecommerce::getEcommerceProductCustomField($w3,$error);
     if($error > 100) // Custom field error
      {
       $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
       $form_title = "Error $error";//$w3->getWord(29); // TODO fare messaggio errore di custom field corretto
      }
	 else
	  {
       switch($error)
        {
         case 1: // Subcategory do not exists
          {
           $_STYLE['subcategoryID'] = WM3_cSKIN_ERROR;
           $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
           $form_title = "Error $error invalid subcategory";//$w3->getWord(29);
           break;
          }
         case 2: // No code
          {
           $_STYLE['code']      = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = "Product ID must be not empty";//$w3->getWord(29);
           break;
          }
         case 3: // No name
          {
           $_STYLE['name']      = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(4);
           break;
          }
         default:
          {
           // Default values for the form
           $_FIELD['categoryID']    = $w3->getVariable('categoryID','get'); // Take categoryID from get
           $_FIELD['subcategoryID'] = $w3->getVariable('subcategoryID','get'); // Take subcategoryID from get
           $_FIELD['enabled']       = WM3_cENABLED;

           $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
           $form_title = $w3->getWord(1665);
          }
		}
      }
     $next_action       = WM3_cACTION_SAVE_ECOMMERCE_PRODUCT;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_ecommerce_product_form.inc");
     return $content;
    }

   public static function editEcommerceProduct($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                               WHERE productID = '".$w3->getVariable('productID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Ecommerce::getEcommerceProductFieldsArray(),$row);
       // Default value for fields not in $row object
       $_FIELD['categoryID'] = $w3->getVariable('categoryID','get'); // Take categoryID from get
	   $custom_fields = wm3Ecommerce::getEcommerceProductCustomField($w3,0,true,true);
      }
     else
	  {
	   $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray());
	   $custom_fields = wm3Ecommerce::getEcommerceProductCustomField($w3,$error);
	  }
     $_STYLE = wm3Skin::getFormStyleArray(wm3Ecommerce::getEcommerceProductFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     if($error > 100) // Custom field error
      {
       $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
       $form_title = "Error $error";//$w3->getWord(29); // TODO fare messaggio errore di custom field corretto
      }
	 else
	  {
       switch($error)
        {
         case 1: // Subcategory do not exists
          {
           $_STYLE['subcategoryID'] = WM3_cSKIN_ERROR;
           $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
           $form_title = "Error $error invalid subcategory";//$w3->getWord(29);
           break;
          }			
         case 2: // No code
          {
           $_STYLE['code']      = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = "Product ID must be not empty";//$w3->getWord(29);
           break;
          }
         case 3: // No name
          {
           $_STYLE['name']      = WM3_cSKIN_ERROR;
           $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
           $form_title = $w3->getWord(4);
           break;
          }
         default:
          {
           $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
           $form_title = "Edit product";//$w3->getWord(29);
          }
		}
      }
     $next_action       = WM3_cACTION_UPDATE_ECOMMERCE_PRODUCT;
     $next_action_label = $w3->getWord(29);
     require(WM3_cPATH_INCLUDE."admin_ecommerce_product_form.inc");
     return $content;
    }

   public static function synchronizeEcommerceProductCustomData($w3)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels WRITE");

     // Synchronize products that have some custom data field missing
	 $productID = $w3->getVariable('productID','get');
	 if(!wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_ecommerce_products","WHERE productID ='$productID'")) // Check if product exists
	  { wm3Sql::sqlQuery("UNLOCK TABLES"); return; }
	 $_FIELD['dataID']     = 0;
	 $_FIELD['productID']  = $productID;
	 $_FIELD['fieldID']    = 0;
	 $_FIELD['value']      = '';
	 $_FIELD['enabled']    = WM3_cENABLED;
	 $_FIELD['languageID'] = WM3_cLANGUAGE_ALL;
	 $_FIELD['ts']         = time();
	 $rs = wm3Sql::sqlQuery("SELECT fieldID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields");
	 while($row = mysql_fetch_object($rs))
	  {
       if(!wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data","WHERE fieldID='".$row->fieldID."' AND productID='$productID'"))
	    {
         $_FIELD['fieldID']   = $row->fieldID;
         wm3Sql::saveAllTableFields('_ecommerce_custom_data',$_FIELD);
	    }
	  }

	 wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function saveEcommerceProduct($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_ecommerce_products',$_FIELD,array('categoryID'));
	 $lastID = wm3Sql::getLastInsertID();

     // Save also custom fields values
	 // TODO fare lock table di ecommerce_custom_fields
     $_VALUE = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomFieldValueArray());
	 $_ID    = array_keys($_VALUE);
	 for($i = 0; $i < sizeof($_VALUE); $i++)
	  {
       $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomDataFieldsArray(),WM3_cQUOTE_DB);
	   $_FIELD['productID']  = $lastID;
	   $_FIELD['fieldID']    = substr($_ID[$i],wm3Ecommerce::getCustomFieldStringName(true));
	   $_FIELD['value']      = wm3Util::quoteDB($_VALUE[$_ID[$i]]);
	   $_FIELD['enabled']    = WM3_cENABLED;
	   $_FIELD['languageID'] = 0;//???
	   $_FIELD['ts']         = time();
	   wm3Sql::saveAllTableFields('_ecommerce_custom_data',$_FIELD);
      }
     return $lastID;
    }

   public static function updateEcommerceProduct($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductFieldsArray(),WM3_cQUOTE_DB);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                       SET   subcategoryID     = '".$_FIELD['subcategoryID']."',
                             userID            = '".$_FIELD['userID']."',
                             code              = '".$_FIELD['code']."',
                             name              = '".$_FIELD['name']."',
                             description       = '".$_FIELD['description']."',
                             full_description  = '".$_FIELD['full_description']."',
							 render_mode       = '".$_FIELD['render_mode']."',
                             price             = '".$_FIELD['price']."',
                             price_description = '".$_FIELD['price_description']."',
                             discount          = '".$_FIELD['discount']."',
                             special           = '".$_FIELD['special']."',
                             stock             = '".$_FIELD['stock']."',
                             availability      = '".$_FIELD['availability']."',
                             options           = '".$_FIELD['options']."',
                             enabled           = '".$_FIELD['enabled']."',
                             languageID        = '".$_FIELD['languageID']."'
                       WHERE productID         = '".$_FIELD['productID']."'");

     // Update custom fields values
//TODO verificare che funzioni quando inserisco un nuovo field dalle preference è non c'è
// nessuna row in ecommerce_custom_data relativa al prodotto da modificare.
     $_VALUE = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomFieldValueArray());
	 $_ID    = array_keys($_VALUE);
	 for($i = 0; $i < sizeof($_VALUE); $i++)
	  {
       $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceProductCustomDataFieldsArray(),WM3_cQUOTE_DB);
	   $_FIELD['value']   = wm3Util::quoteDB($_VALUE[$_ID[$i]]);
	   $_FIELD['fieldID'] = substr($_ID[$i],wm3Ecommerce::getCustomFieldStringName(true));
	   //$_FIELD['enabled'] = WM3_cENABLED;
       wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                         SET value       = '".$_FIELD['value']."'
                         WHERE productID = '".$_FIELD['productID']."' AND
						       fieldID   = '".$_FIELD['fieldID']."'");
      }
     return $_FIELD['productID'];
    }

   public static function duplicateEcommerceProduct($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '".$w3->getVariable('newsID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Ecommerce::getEcommerceFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       //$_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $_FIELD['ts'] = time();
       //wm3Sql::saveAllTableFields('_news',$_FIELD,array('update_ts'));
       wm3Sql::saveAllTableFields('_news',$_FIELD);
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disableEcommerceProduct($productID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products SET enabled = '".WM3_cDISABLED."' WHERE productID = '$productID'");
	}

   public static function enableEcommerceProduct($productID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products SET enabled = '".WM3_cENABLED."' WHERE productID = '$productID'");
	}
   
   public static function deleteEcommerceProduct($productID)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data       WRITE");
     // Delete also the images, cart items (no ordered) and custom data
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE productID = '$productID'");
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE productID = '$productID' AND orderID = '0'");
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data WHERE productID = '$productID'");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = '$productID'");
     wm3Sql::sqlQuery("UNLOCK TABLES");	 
	}

   public static function addEcommercePicture($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Ecommerce::getEcommercePictureFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommercePictureFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";

     // Hide/Show correct field and error
     $_EXTRA_STYLE['picture_from_local'] = $_EXTRA_STYLE['picture_from_remote'] = "style=\"display:none\"";
     if($_FIELD['picture_from']   == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['picture_from_remote'] = "";
	 else                                                     $_EXTRA_STYLE['picture_from_local']  = "";
	 $_EXTRA_STYLE['thumbnail_from_local'] = $_EXTRA_STYLE['thumbnail_from_remote'] = "style=\"display:none\"";
     if($_FIELD['thumbnail_from'] == WM3_cUPLOAD_FROM_REMOTE) $_EXTRA_STYLE['thumbnail_from_remote'] = "";
	 else                                                     $_EXTRA_STYLE['thumbnail_from_local']  = "";

     if($error)
      {
       // Delete bad uploaded files (if exists)
       if(file_exists(WM3_cPATH_ECOMMERCE.$_FILES['picture_from_local']['name']))   @unlink(WM3_cPATH_ECOMMERCE.$_FILES['picture_from_local']['name']);
       if(file_exists(WM3_cPATH_ECOMMERCE.$_FILES['thumbnail_from_local']['name'])) @unlink(WM3_cPATH_ECOMMERCE.$_FILES['thumbnail_from_local']['name']);
      }
     switch($error)
      {
       // Picture error
       case 1: // Upload error
        {
         $_STYLE['picture_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
         $form_title = "Error Upload error $error";//$w3->getWord(29);
         break;
        }
       case 2: // File not allowed
        {
         $_STYLE['picture_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
         $form_title = "Error Not allowed $error";//$w3->getWord(29);
         break;
        }
       case 5: // File too big
        {
         $_STYLE['picture_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
         $form_title = "Error Too big $error";//$w3->getWord(29);
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_STYLE['picture_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']     = WM3_cSKIN_ERROR;
         $form_title = "Error no file specified $error";//$w3->getWord(29);
         break;
        }
       // Thumbnail upload error
       case 7: // Upload error
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "Upload error $error";//$w3->getWord(29);
         break;
        }
       case 8: // File not allowed
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "File not allowed $error";//$w3->getWord(29);
         break;
        }
       case 11: // File too big
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "File too big $error";//$w3->getWord(29);
         break;
        }
       case 12: // Empty file given (no upload performed)
        {
         $_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "Empty file name $error";//$w3->getWord(29);
         break;
        }
       case 13: // Invalid products
        {
         //$_STYLE['thumbnail_from_local'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']       = WM3_cSKIN_ERROR;
         $form_title = "Invalid products $error";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID']    = $w3->getVariable('categoryID','get');    // Take categoryID from get
         $_FIELD['subcategoryID'] = $w3->getVariable('subcategoryID','get'); // Take subcategoryID from get
         $_FIELD['productID']     = $w3->getVariable('productID','get');     // Take productID from get
         $_FIELD['enabled']       = WM3_cENABLED;
         $_FIELD['picture_from']  = $FIELD['thumbnail_from'] = WM3_cUPLOAD_FROM_LOCAL;
         //$_EXTRA['update_ts'] = "";
       
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1667);
       	}
      }
     $preview_image     = $_FIELD['picture_from_remote'];   if(!$preview_image)     $preview_image     = wm3Util::getFirstFile(WM3_cPATH_ECOMMERCE); // Set due preview image
     $preview_thumbnail = $_FIELD['thumbnail_from_remote']; if(!$preview_thumbnail) $preview_thumbnail = wm3Util::getFirstFile(WM3_cPATH_ECOMMERCE); // Set due preview image
     $next_action       = WM3_cACTION_SAVE_ECOMMERCE_PICTURE;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_ecommerce_picture_form.inc");
     return $content;
    }

   public static function saveEcommercePicture($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommercePictureFieldsArray(),WM3_cQUOTE_DB);
     //$_FIELD['message_ts'] = $_FIELD['ts'] = time();
     //wm3Sql::saveAllTableFields('_ecommerce_products',$_FIELD,array('update_ts'));
     if($_FIELD['picture_from']   == WM3_cUPLOAD_FROM_LOCAL) $_FIELD['picture']   = $_FILES['picture_from_local']['name'];   else $_FIELD['picture']   = $_FIELD['picture_from_remote'];
     if($_FIELD['thumbnail_from'] == WM3_cUPLOAD_FROM_LOCAL) $_FIELD['thumbnail'] = $_FILES['thumbnail_from_local']['name']; else $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_remote'];
     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_ecommerce_products_pictures',$_FIELD,array('categoryID','subcategoryID','picture_from_local','picture_from_remote','thumbnail_from_local','thumbnail_from_remote','picture_from','thumbnail_from'));
     return wm3Sql::getLastInsertID();
    }

   public static function disableEcommercePicture($pictureID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures SET enabled = '".WM3_cDISABLED."' WHERE pictureID = '$pictureID'");
	}

   public static function enableEcommercePicture($pictureID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures SET enabled = '".WM3_cENABLED."' WHERE pictureID = '$pictureID'");
	}

   public static function deleteEcommercePicture($pictureID)
    {
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures WHERE pictureID = '$pictureID'");
    }

   public static function acceptEcommerceOrder($orderID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_ACCEPT."'
	                   WHERE orderID = '$orderID' AND status = '".WM3_cECOMMERCE_ORDER_WAITING."'");
	}

   public static function rejectEcommerceOrder($orderID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_REJECT."'
	                   WHERE orderID = '$orderID' AND status = '".WM3_cECOMMERCE_ORDER_WAITING."'");
	}

   public static function sendEcommerceOrder($orderID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_SENDED."'
	                   WHERE orderID = '$orderID' AND status = '".WM3_cECOMMERCE_ORDER_ACCEPT."'");
	}

   public static function waitEcommerceOrder($orderID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                   SET status = '".WM3_cECOMMERCE_ORDER_WAITING."'
	                   WHERE orderID = '$orderID' AND (status = '".WM3_cECOMMERCE_ORDER_ACCEPT."' OR status = '".WM3_cECOMMERCE_ORDER_REJECT."')");
	}

   public static function deleteEcommerceOrder($orderID)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
                                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
  		 		                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items   WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders        WRITE");
	 $status = wm3Ecommerce::getEcommerceOrderStatus($orderID);
	 if($status == WM3_cECOMMERCE_ORDER_WAITING || $status == WM3_cECOMMERCE_ORDER_REJECT)
	  {
	   wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE orderID = '$orderID'");
       wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders WHERE orderID = '$orderID'");
      }
	 wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   /*public static function selectEcommerceProducts($name,$messageID)
    {
     // Make message categories select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages");
     $str = "<select name=\"$name\">";
     while($row = mysql_fetch_object($rs))
      {
       if($row->messageID == $messageID) $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID,"selected");
       else                              $str .= wm3Util::inputOption($row->arg_name,$row->arg_blockID);
      }
     $str .= "</select>";
     return $str;
    }*/

   public static function getEcommerceProductCode($w3,$productID,$label = false)
    {
     // Get a product name
     $rs = wm3Sql::sqlQuery("SELECT code FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     if(mysql_num_rows($rs) != 1) if($label) return $label; else return "";
     $row = mysql_fetch_object($rs);
     return $row->code;
    }

   public static function getEcommerceProductName($w3,$productID,$label = false)
    {
     // Get a product name
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     if(mysql_num_rows($rs) != 1) if($label) return $label; else return "";
     $row = mysql_fetch_object($rs);
     return $row->name;
    }

   public static function getEcommerceProductDescription($w3,$productID,$label = false)
    {
     // Get a product name
     $rs = wm3Sql::sqlQuery("SELECT description FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     if(mysql_num_rows($rs) != 1) if($label) return $label; else return "";
     $row = mysql_fetch_object($rs);
     return $row->description;
    }

   public static function getEcommerceProductPrice($w3,$productID)
    {
     // Get a product price
     $rs = wm3Sql::sqlQuery("SELECT price FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     $row = mysql_fetch_object($rs);
     return $row->price;
    }

   public static function getEcommerceProductDiscount($w3,$productID)
    {
     // Get a product discount
     $rs = wm3Sql::sqlQuery("SELECT discount FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE productID = '$productID'");
     $row = mysql_fetch_object($rs);
     return $row->discount;
    }

   public static function getEcommerceOrderUserID($orderID)
    {
     // Return userID from orderID
     $rs = wm3Sql::sqlQuery("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                             WHERE orderID = '$orderID'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->userID;
    }

   public static function getEcommerceOrderTotal($w3,$orderID)
    {
     // Get an order total price (with shipping costs)
     $rs = wm3Sql::sqlQuery("SELECT SUM(price*quantity) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                             WHERE orderID = '$orderID'");
     $row = mysql_fetch_object($rs);
     return $row->total;//+$row->shipping_cost da tabella orders; TODO
    }

   public static function getEcommerceCustomFieldLabel($fieldID,$languageID)
    {
	 // Get actual language field label
	 $rs = wm3Sql::sqlQuery("SELECT label FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
	                         WHERE fieldID='$fieldID' AND languageID='$languageID'");
     if(mysql_num_rows($rs) != 1) return "";
	 $row = mysql_fetch_object($rs);
	 return $row->label;
	}

   public static function selectEcommerceProductOptions($w3,$options)
    {
     // Get ecommerce product options selects (home side)
     $i = 0; $token = strtok($options,"|");
     while($token)
	  {
	   $_ROW[$i] = $token;
       $token = strtok("|");
	   $i++;
      }
	 if($i == 0) return "";

     for($i = 0; $i < sizeof($_ROW); $i++)
      {
	   $j = 0; $token = strtok($_ROW[$i],","); $_ITEM = array();
       while($token)
	    {
	     if($j == 0) $_LABEL[$i] = $token; else $_ITEM[$j-1] = $token;
         $token = strtok(",");
	     $j++;
        }
	   $value = $w3->getVariable('option'.$i,'both');
	   $_SELECT[$i] = wm3Util::selectArrayEquals('option'.$i,$_ITEM,$value);
	  }

     $str = "";
	 $_STYLE = wm3Skin::getFormStyleArray(array('odd','even'));
     for($i = 0; $i < sizeof($_SELECT); $i++)
      {
	   if($i%2 == 0) $style = "even"; else $style = "odd";
	   $str .= wm3Section::makeFormItem($w3,$_STYLE[$style],$_LABEL[$i],$_SELECT[$i]);
	   $str .= wm3Util::inputHidden('option_label'.$i,$_LABEL[$i]);
      }
     return $str;
    }

   public static function selectEcommerceProductAvailability($w3,$name,$value)
    {
     // Make ecommerce product availability select
     return wm3Util::selectArray($name,
                        array($w3->getWord(679),$w3->getWord(680),$w3->getWord(681),$w3->getWord(682)),
                        array(WM3_cECOMMERCE_AVAILABILITY_HEIGHT,WM3_cECOMMERCE_AVAILABILITY_EVERAGE,WM3_cECOMMERCE_AVAILABILITY_LOW,WM3_cECOMMERCE_AVAILABILITY_NONE),
                        $value);
    }

   public static function selectEcommercePictureFrom($w3,$name,$value,$js = '')
    {
     // Make ecommerce picture from type select
     return wm3Util::selectArray($name,
                        array($w3->getWord(-1)."From local drive",$w3->getWord(-1)."From remote folder"),
                        array(WM3_cUPLOAD_FROM_LOCAL,WM3_cUPLOAD_FROM_REMOTE),
                        $value,
                        $js);
    }

   public static function renderEcommerceSpecialOffer($w3)
    {
     // Render ecommerce special offer panel (for home page)
     $columns = 1; $buttons = 0;
	 $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME;
     $pageID = $w3->getVariable('pageID','both');
     $page_link = "&pageID=$pageID";

     // Do the query and take the total items number
     $query = "SELECT   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                        ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                        ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.*
               FROM     ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                        ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                        ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
               WHERE    ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                        ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID
                 AND    ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.languageID='".WM3_cLANGUAGE_ALL."')
				 AND    ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.special = '".WM3_cENABLED."'
 			   ORDER BY RAND() LIMIT 1";
     $rs = wm3Sql::sqlQuery($query);
     $total_items = mysql_num_rows($rs);

     // Create list header
     $str = wm3Section::makeHeaderList($w3,array(),array());

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,1639);

     // Create special offer question and answers
     $link = $base_link.$page_link;
     $row = mysql_fetch_object($rs);
	 $subcategoryID = $row->subcategoryID;
	 $categoryID = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);
     $image = "<div align=\"center\"><a href=\"$link&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">".wm3Ecommerce::getEcommercePictureFirst($w3,0,$row->subcategoryID,$row->productID)."</a></div>";
     $name = "<div align=\"center\"><a href=\"$link&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT."\">$row->name</a></div>";
     $str .= wm3Section::makeItemList($w3,0,array(100),array($image),false);
     $str .= wm3Section::makeItemList($w3,0,array(100),array($name),false);
	 $currency = $w3->getPreferences('ecommerce_currency');
	 if($row->discount > 0) $info = "<s>$row->price $currency $row->price_description</s><br>".($row->price-($row->price*$row->discount/100))." $currency $row->price_description <i>(".$w3->getWord(1500)." $row->discount %)</i>";
	 else                   $info = "$row->price $currency $row->price_description";
	 $info = "<div align=\"center\">$info</div>";
     $str .= wm3Section::makeItemList($w3,0,array(100),array($info),false);
     $more = "<div align=\"center\"><a href=\"$link&action=".WM3_cACTION_SHOW_ECOMMERCE_SPECIAL_OFFER."\">".$w3->getWord(1640)." > </a></div>";
     $str .= wm3Section::makeItemList($w3,0,array(100),array($more),false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderEcommerceCart($w3,$currentID = 0,$admin = true,$order = false)
    {
     // Get current user cart content (home side)

     wm3Ecommerce::expireEcommerceCart($w3);

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg','both');
     $search_link = $query_filter = "";
	 $userID = $w3->getAuthenticateUserID();
     $width_product  = 50;
	 $width_quantity = 10;
	 $width_price    = 10;
	 $width_data     = 30;
     $query_filter = " WHERE userID = '$userID' AND orderID = '0'";
     if($allowed) { $columns = 6; $buttons = 2; } else { $columns = 5; $buttons = 1; }

     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'messageID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array(); $search_form = "";
     if($admin)
      {
       require(WM3_cPATH_INCLUDE."admin_message_search_form.inc");
       array_push($_CONTENTS,$w3->getWord(1142));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     $str .= wm3Section::makeCaptionList($w3,array($width_product,$width_quantity,$width_price,$width_data,0),array(737,677,674,807),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0)
	  {
	   array_push($_CONTENTS,"<br>".wm3Util::actionButton("$base_link&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER,"misc_orders.png","","",$w3->getWord(1662))."<br><br>");
	   $str .= wm3Section::makeItemList($w3,0,array(100),array($w3->getWord(691)),false,array($columns));
       $str .= wm3Section::makeItemList($w3,1,array(100),$_CONTENTS,false,array($columns));
	   $str .= wm3Section::makeBottomList($w3,$columns);
	   return $str;
      }

     // Create list items
     $p = 0; $total = 0;
	 $currency = $w3->getPreferences('ecommerce_currency');
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&cart_itemID=$row->cart_itemID";
       if($allowed) $allowed_link = $base_allowed_link."&productsID=$row->productID";
       $subcategoryID = wm3Ecommerce::getEcommerceSubcategoryID($w3,$row->productID);
       $categoryID    = wm3Ecommerce::getEcommerceCategoryID($w3,$subcategoryID);
	   $product = ($p+1)." ".wm3Util::makeLink($w3,WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$row->productID&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT,wm3Ecommerce::getEcommerceProductName($w3,$row->productID));
	   $date    = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
	   // TODO Discount
       array_push($_CONTENTS,$product);       array_push($_WIDTHS,$width_product);
       array_push($_CONTENTS,$row->quantity); array_push($_WIDTHS,$width_quantity);
	   array_push($_CONTENTS,$row->price);    array_push($_WIDTHS,$width_price);
	   array_push($_CONTENTS,$date);          array_push($_WIDTHS,$width_data);
       // Buttons
       array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_ECOMMERCE_CART_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(695)));
       if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_ECOMMERCE_PRODUCT,"action_edit.png",$w3->getWord(178)));

       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->cart_itemID==$currentID);
       $p++; $total = $total + $row->price * $row->quantity;  // TODO Discount
      }
	 if($order)
	  {
	   // Shipping cost
	   $shipping = $w3->getPreferences('ecommerce_shipping_cost');
	   if($shipping > 0)
	    {
         $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,array($w3->getWord(1034)." ($currency)","",$shipping,"","",""),false);
	     $total = $total + $shipping;
        }
	   // Total
       $str .= wm3Section::makeItemList($w3,$p+1,$_WIDTHS,array("<b>".$w3->getWord(1395)." ($currency)</b>","","<b>".$total."</b>","","",""),false);
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     // Other ecommerce cart buttons
	 $_CONTENTS = array();
     if(!$order)
	  {
	   array_push($_CONTENTS,"<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_PROCESS_ECOMMERCE_ORDER,"misc_cart_order.png","","",$w3->getWord(718))."<br><br>");
	   array_push($_CONTENTS,"<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_ORDER,"misc_orders.png","","",$w3->getWord(1662))."<br><br>");
      }
	 else
	  {
	   array_push($_CONTENTS,"<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_CONFIRM_ECOMMERCE_ORDER,"misc_cart_order.png","",$w3->getWord(759)." (".$w3->getWord(1395)." $total $currency)","Confirm ".$w3->getWord(718))."<br><br>");
	   array_push($_CONTENTS,"<br>".wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SHOW_ECOMMERCE_CART,"misc_cart.png","","",$w3->getWord(692))."<br><br>");
      }

     $str .= wm3Section::makeHeaderList($w3,array(),2);
     $str .= wm3Section::makeItemList($w3,$p+2,array(50,50),$_CONTENTS,false);
	 $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function deleteEcommerceCartItem($w3,$cart_itemID)
    {
	 //TODO gestire bene ritorno prodotti in magazzino...
	 $userID = $w3->getAuthenticateUserID();
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE cart_itemID = '$cart_itemID' AND userID = '$userID' AND orderID = '0'");
	}

   public static function expireEcommerceCart($w3)
    {
	 // Delete item cart when are expired due to "ecommerce_cart_expire" preference
	 //TODO gestire bene ritorno prodotti in magazzino...
	 $ts = time() - $w3->getPreferences('ecommerce_cart_expire') *  86400;
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items WHERE ts < '$ts' AND orderID = '0'");
	}

   public static function getEcommercePictureFirst($w3,$categoryID,$subcategoryID,$productID,$pictureID = '',$thumbnail = true,$msg = 592)
    {
     // Get first picture or thumbnail (or $pictureID if defined) for a products (home side)
	 $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.languageID='".WM3_cLANGUAGE_ALL."')";
	 if($pictureID) $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.pictureID = '$pictureID'";
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.ts";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products,
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.subcategoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products.productID=".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID AND
                      ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures.productID = '$productID'
               $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT 0,1"); // Do the query limited to the first row
     $total_items = mysql_num_rows($rs);
     if($total_items != 1)
	  {
	   return $w3->getWord($msg); // No picture
      }
     else
	  {
	   $row = mysql_fetch_object($rs);
	   if($thumbnail) $picture = $row->thumbnail; else $picture = $row->picture;
	   return "<img src=\"".WM3_cPATH_ECOMMERCE."$picture\" border=\"0\" alt=\"$row->description\" title=\"$row->description\">";
      }
    }

   public static function getEcommerceProductCustomFieldLabel($w3,$fieldID,$admin = false)
    {
     // Get label for a custom ecommerce field (for actual languageID)
	 if($admin) $languageID = $w3->getAdminLanguage(); else $languageID = $w3->getHomeLanguage();
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
               WHERE  fieldID = '$fieldID' AND languageID = '$languageID'";
     $rs = wm3Sql::sqlQuery($query);
     if(mysql_num_rows($rs) != 1) return "";
     $row = mysql_fetch_object($rs);
     return $row->label;
	}

   public static function saveEcommerceCartItem($w3)
    {
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
                                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
  		 		                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items   WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders        WRITE");
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceCartItemFieldsArray(),WM3_cQUOTE_DB);
	 if($_FIELD['quantity'] <= 0) { wm3Sql::sqlQuery("UNLOCK TABLES"); return 1; } // Bad quantity
	 if(!wm3Ecommerce::existsEcommerceProduct($_FIELD['productID'])) { wm3Sql::sqlQuery("UNLOCK TABLES"); return 2; } // Invalid product
	 $_FIELD['enabled']  = WM3_cENABLED;
	 $_FIELD['orderID']  = 0;
	 $_FIELD['userID']   = $w3->getAuthenticateUserID();
	 $_FIELD['price']    = wm3Ecommerce::getEcommerceProductPrice($w3,$_FIELD['productID']);
	 $_FIELD['discount'] = wm3Ecommerce::getEcommerceProductDiscount($w3,$_FIELD['productID']);

     $i = 0;
     while($w3->getVariable('option_label'.$i,'both'))
	  {
	   if($i == 0) $_FIELD['options'] .= $w3->getVariable('option_label'.$i,'both');
	   else        $_FIELD['options'] .= "|".$w3->getVariable('option_label'.$i,'both');
	   $_FIELD['options'] .= ",".$w3->getVariable('option'.$i,'both');
	   $i++;
      }

     $_FIELD['ts'] = time();
     wm3Sql::saveAllTableFields('_ecommerce_carts_items',$_FIELD);
	 
	 wm3Sql::sqlQuery("UNLOCK TABLES");
     return 0;
    }

   public static function saveEcommerceCartOrder($w3)
    {
	 //TODO fare protezione da "reinvio form a causa di doppio click" (serve davvero visto che non si puo' ordinare se il carrello è vuoto???)
	 $userID = $w3->getAuthenticateUserID();
     wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
                                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
  		 		                   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items   WRITE,
							       ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders        WRITE");
     $_FIELD = webmatic3::getPostValueArray(wm3Ecommerce::getEcommerceOrderItemFieldsArray(),WM3_cQUOTE_DB);
	 //if($_FIELD['quantity'] <= 0) return 0; // Bad quantity
	 $_FIELD['userID']        = $userID;
	 $_FIELD['status']        = WM3_cECOMMERCE_ORDER_WAITING;
	 $_FIELD['shipping_cost'] = $w3->getPreferences('ecommerce_shipping_cost');
	 $_FIELD['enabled']       = WM3_cENABLED;
	 $_FIELD['ts'] = $_FIELD['order_ts'] = time();

     // Check if cart its empty and an user try to order
     $rs = wm3Sql::sqlQuery("SELECT productID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                             WHERE orderID = '0' AND userID = '$userID'");
     if(mysql_num_rows($rs) < 1)
      {
       wm3Sql::sqlQuery("UNLOCK TABLES");
       return "Order already processed!";
      }

     // Save order
     wm3Sql::saveAllTableFields('_ecommerce_orders',$_FIELD);
	 $orderID = wm3Sql::getLastInsertID();
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                   SET orderID = '$orderID' WHERE orderID = '0' AND userID = '$userID'");
     // Update product informations in the carts items
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                             WHERE orderID = '$orderID' AND userID = '$userID'");
     while($row = mysql_fetch_object($rs))
      {
	   $product_code        = wm3Util::quoteDB(wm3Ecommerce::getEcommerceProductCode($w3,$row->productID));
	   $product_name        = wm3Util::quoteDB(wm3Ecommerce::getEcommerceProductName($w3,$row->productID));
	   $product_description = wm3Util::quoteDB(wm3Ecommerce::getEcommerceProductDescription($w3,$row->productID));
	   wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                        SET product_code        = '$product_code',
		  				        product_name        = '$product_name',
						        product_description = '$product_description'
					      WHERE cart_itemID = '$row->cart_itemID' AND orderID = '$orderID' AND userID = '$userID'");
      }
     // Create header
	 $columns = 2;
     $_WIDTHS = array(30,70);
     $str = wm3Section::makeHeaderList($w3,array("Order confirmed:<br><br>"),$columns);

     // Create items
	 $_CONTENTS = array(); 
	 array_push($_CONTENTS,"Order number","<b>$orderID</b>");
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);
	 $_CONTENTS = array();
	 array_push($_CONTENTS,"Order date","<b>".wm3Util::renderDate($w3,$_FIELD['order_ts'],$w3->getHomeLanguage())."</b>");
	 $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false);
	 $_CONTENTS = array();
	 $currency = $w3->getPreferences('ecommerce_currency');
	 $total = wm3Ecommerce::getEcommerceOrderTotal($w3,$orderID);
	 array_push($_CONTENTS,"Order total","<b>$total $currency</b>");
	 $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

	 $_CONTENTS = array();
	 $url = $w3->getPreferences('ecommerce_credit_card_url')."?".$w3->getPreferences('ecommerce_variable_id')."=$orderID&".$w3->getPreferences('ecommerce_variable_price')."=$total";
	 array_push($_CONTENTS,"<br>".$w3->getWord(761)." ".wm3Util::actionButton($url,"misc_cart.png","","",$w3->getWord(762),0,24,24,"absmiddle","_blank")."<br><br>");
     $str .= wm3Section::makeItemList($w3,1,$_WIDTHS,$_CONTENTS,false,array(2));

     // Create bottom
	 $str .= wm3Section::makeBottomList($w3,$columns);

	 wm3Sql::sqlQuery("UNLOCK TABLES");
     return $str;
    }

   public static function getCustomFieldStringName($lenght = false)
    {
	 $str = "custom_field";
	 if($lenght) return strlen($str);
	 else        return $str;
	}

   public static function getEcommerceOrderStatus($orderID)
    {
     // Get order status from orderID
     $rs = wm3Sql::sqlQuery("SELECT status FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                             WHERE  orderID = '$orderID'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->status;
	}

   private static function existsEcommerceProduct($productID)
    {
     // Return true if the product with productID exists else return false
     $rs = wm3Sql::sqlQuery("SELECT productID FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                             WHERE  productID = '$productID'");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
	}

   public static function isUsedEcommercePicture($file)
    {
	 // Return true if a picture its used in a row
	 $rs = wm3Sql::sqlQuery("SELECT pictureID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
							 WHERE  picture = '$file' OR  thumbnail = '$file'");
     if(mysql_num_rows($rs) == 0) return false;
	 else                         return true;
    }

  }

?>
