<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Folder
  {

   function __construct() { }

   public static function getFolderFieldsArray($w3)
    {
     $_ARRAY['pathID'] = array(WM3_cFOLDER_ALL,WM3_cFOLDER_IMG,WM3_cFOLDER_ECOMMERCE,WM3_cFOLDER_MEDIA_ALBUM,WM3_cFOLDER_DOWNLOADS);
     $_ARRAY['path']   = array('',WM3_cPATH_IMAGES,WM3_cPATH_ECOMMERCE,WM3_cPATH_MEDIA_ALBUM,WM3_cPATH_DOWNLOADS);
     $_ARRAY['label']  = array('All folder','Image folder','Ecommerce folder','Media album folder','Downloads');
     $_ARRAY['icon']   = array('','misc_folder.png','misc_folder.png','misc_folder.png','misc_folder.png');
     return $_ARRAY;
    }

   public static function getFolderFileFieldsArray()
    {
     return array('file1','file2','file3','file4','file5',
                  'path1ID','path2ID','path3ID','path4ID','path5ID',
                  'overwrite1','overwrite2','overwrite3','overwrite4','overwrite5');
    }

   public static function getMimeInfoArray($w3,$file)
    {
	 // TODO in futuro usare funzioni mime type di php...
	 $ext = wm3Util::cutExtension($file);
	 $mime_icon = ""; // TODO mime_document...
	 if($ext == "avi" || $ext == "mpeg" || $ext == "asf"  || $ext == "wmv")                   { $mime_type = "video"; $mime_icon = "mime_video.png"; }
	 if($ext == "mp3" || $ext == "wav"  || $ext == "ogg"  || $ext == "mid" || $ext == "midi") { $mime_type = "audio"; $mime_icon = "mime_audio.png"; }
	 if($ext == "png" || $ext == "jpg"  || $ext == "jpeg" || $ext == "gif" || $ext == "bmp")  { $mime_type = "image"; $mime_icon = "mime_image.png"; }
	 return array(
	              'mime_type' => $mime_type,
				  'mime_icon' => wm3Util::renderImg("$mime_icon",'',24,24)
	             );
	}

   public static function mimeTypeImage()
    {
     return array('image/jpeg','image/pjpeg','image/gif','image/png','image/bmp','image/x-windows-bmp');
    }

   public static function mimeTypeAudio()
    {
     return array('audio/mpeg','audio/wav','audio/mid','audio/x-mid','audio/x-midi');
    }

   public static function mimeTypeVideo()
    {
     return array('video/avi','video/mpeg','video/x-ms-asf','video/msvideo','video/x-msvideo','video/quicktime');
    }

   public static function mimeTypeApplication()
    {
     return array('application/x-zip-compressed','application/zip','application/x-bzip','application/x-bzip2','application/x-gzip','application/x-compressed','application/x-gtar','application/x-msdownload');
    }

   public static function mimeTypeDocument()
    {
     return array('text/plain','application/msword','application/mspowerpoint','application/powerpoint','application/excel','application/pdf');
    }

   public static function mimeTypeEmail($i = '')
    {
     $_TYPES = array('text','multipart','message','application','audio','image','video','other');
	 if($i) return $_TYPES[$i];
	 else   return $_TYPES;
    }

   public static function mimeTypeImageAudioVideo()
    {
     return array_merge(wm3Folder::mimeTypeImage(),
                        wm3Folder::mimeTypeAudio(),
                        wm3Folder::mimeTypeVideo());
    }

   public static function mimeTypeImageAudio()
    {
     return array_merge(wm3Folder::mimeTypeImage(),
                        wm3Folder::mimeTypeAudio());
    }

   public static function mimeTypeImageVideo()
    {
     return array_merge(wm3Folder::mimeTypeImage(),
                        wm3Folder::mimeTypeVideo());
    }

   public static function mimeTypeAudioVideo()
    {
     return array_merge(wm3Folder::mimeTypeAudio(),
                        wm3Folder::mimeTypeVideo());
    }

   public static function mimeTypeApplicationDocument()
    {
     return array_merge(wm3Folder::mimeTypeApplication(),
                        wm3Folder::mimeTypeDocument());
    }

   public static function renderFileSize($w3,$byte,$label = '')
    {
	 if($byte === false) return "$label unknown";
	 if($byte < 10240)                     { $size = $byte;                $unit = "byte"; }
	 if($byte >= 10240 && $byte < 2097152) { $size = $byte/1024;           $unit = "Kbyte"; }
	 if($byte >= 2097152)                  { $size = $byte/1024/1024;      $unit = "Mbyte"; }
	 $size = round($size,2);
	 return "$label $size $unit";
	}

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FILE_FOLDER:
        {
         return wm3Folder::addFolderFile($w3);
         break;
        }
       case WM3_cACTION_UPLOAD_FILE_FOLDER:
        {
         $_ERROR = wm3Folder::checkFolderFileError($w3);
         /*if(!$_ERROR)
          {
           //$lastID = wm3Folder::uploadFolderFile($w3);
           // $msg= faq saved... //TODO
           return wm3Folder::getFolderList($w3,$lastID);
          }*/
         //else 
         return wm3Folder::addFolderFile($w3,$_ERROR);
         break;
        }
       /*case WM3_cACTION_EDIT_FAQ:
        {
         return wm3Faq::editFaq($w3);
         break;
        }
       case WM3_cACTION_UPDATE_FAQ:
        {
         $error = wm3Faq::checkFaqError($w3);
         if(!$error)
          {
           $lastID = wm3Faq::updateFaq($w3);
           // $msg= message udated... //TODO
           return wm3Faq::getFaqList($w3,$lastID);
          }
         else return wm3Faq::editFaq($w3,$error);
         break;
        }*/
       case WM3_cACTION_DELETE_FILE_FOLDER:
        {
         wm3Folder::deleteFolderFile($w3,$w3->getVariable('pathID','get'));
         return wm3Folder::showFolder($w3);
         break;
        }
       case WM3_cACTION_DELETE_FILE_TEMP_FOLDER:
        {
         wm3Folder::deleteFolderFile($w3,0,true);
         return wm3Folder::showFolder($w3,0,true,true);
         break;
        }
       case WM3_cACTION_EMPTY_FILE_TEMP_FOLDER:
        {
		 wm3Folder::deleteFolderAllFile(WM3_cPATH_TEMP);
         return wm3Folder::showFolder($w3,0,true,true);
         break;
		}
       case WM3_cACTION_SHOW_FILE_TEMP_FOLDER:
        {
         return wm3Folder::showFolder($w3,0,true,true);
         break;
        }
       default:
        {
         return wm3Folder::showFolder($w3);
        }
      }     
    }

   public static function showAllFolders($w3,$admin = true)
    {
     // Show all folders status

     // Prepare variables to create the list
     $pathID = 0;
     $filter = "";
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FOLDERS); // Used to enable admin buttons in home stage
     $width_name = $width_informations = 50;
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_FAQ;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 4; $buttons = 1;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FAQ."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         if($allowed) { $columns = 4; $buttons = 1; } else { $columns = 3; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FAQ;

     // Create list header
     $_CONTENTS = array();
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_folder_search_form.inc");
     array_push($_CONTENTS,$w3->getWord(357));
     //if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_FAQ,"action_add.png","","",$w3->getWord(1657),0,16,16));
     //else       array_push($_CONTENTS," $_SEP Make a question TODO".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_ADD_FAQ,"action_down.png","","",$w3->getWord(1657),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(0,$width_name,$width_informations,0),array(1670,194,1671,0),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     $_ARRAY = wm3Folder::getFolderFieldsArray($w3);
     $total_items = sizeof($_ARRAY['path']);
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0; $total_size = 0;
     for($i = 1; $i < $total_items; $i++)
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link."&pathID=$i";
       if($allowed) $allowed_link = $base_allowed_link;//."&pathID=$i";
       $folder_icon  = "<a href=\"$link\"><img src=\"".WM3_cPATH_DATA.$_ARRAY['icon'][$i]."\" border=\"0\" width=\"36\" height=\"36\"></a>";
       $folder_name  = "<a href=\"$link\">".$_ARRAY['label'][$i]."</a><br>(".$_ARRAY['path'][$i].")";
       $folder_size  = wm3Folder::getFolderSize($_ARRAY['path'][$i]);
       $folder_items = wm3Folder::getFolderItems($_ARRAY['path'][$i]);
       $total_size += $folder_size;
       array_push($_CONTENTS,$folder_icon); array_push($_WIDTHS,0);
       array_push($_CONTENTS,$folder_name); array_push($_WIDTHS,$width_name);
       array_push($_CONTENTS,"$folder_items files<br>($folder_size bytes)"); array_push($_WIDTHS,$width_informations);
       if($admin) 
        {
         // Buttons
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_FILE_FOLDER,"action_add_from.png",$w3->getWord(264)));
         //array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FAQ,"action_delete.png",$w3->getWord(179),$w3->getWord(96)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FAQ,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false); // TODO sostituire false con $xxxx == $currentID ????
       $p++;
      }

     // Folders total size
     $str .= wm3Section::makeItemList($w3,$p,array(0,$width_name,$width_informations),array("","<b>Folders total size:</b>","<b>".wm3Folder::renderFileSize($w3,$total_size)."</b>",""),false);

     // Create list bottom
	 $str .= wm3Section::makeBottomList($w3,$columns,'');

     return $str;
    }

   public static function showFolder($w3,$currentID = 0,$admin = true, $temp = false)
    {
     // Show the files in a folder
     if($temp)
      {
	   $pathID = 0;
       $_ARRAY['path'][0]  = WM3_cPATH_TEMP;
       $_ARRAY['label'][0] = "Temporary folder";
	  }
     else
      {
       $pathID = $w3->getVariable('pathID','both');
       $_ARRAY = wm3Folder::getFolderFieldsArray($w3);
       if($pathID <= 0 || $pathID >= sizeof($_ARRAY['path'])) return wm3Folder::showAllFolders($w3);
      }
     $path        = $_ARRAY['path'][$pathID];
     $folder_name = $_ARRAY['label'][$pathID];

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FOLDERS); // Used to enable admin buttons in home stage
     $filter  = $w3->getVariable('filter','both'); // Search field
     $pg      = $w3->getVariable('pg','both');
     $width_name = $width_informations = 50;
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg)     $extra_link  = "&pg=$pg"; else $extra_link = "";
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_FAQ;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 3; $buttons = 1;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FAQ."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         if($allowed) { $columns = 3; $buttons = 1; } else { $columns = 2; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FAQ;
     $id_link = "&pathID=$pathID";

     // Do the query and take the total items number
     $total_items = wm3Folder::getFolderItems($path);
     //if($total_items != 0) $rs = wm3Sql::sqlQuery($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_faqs.question DESC LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
	 $_SEP  = $w3->getSkinObj()->getSeparator();
	 $_PSEP = $w3->getSkinObj()->getPathSeparator();
     require(WM3_cPATH_INCLUDE."admin_folder_search_form.inc");
     if($admin) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(357)."</a>");
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(357)."</a>");
     array_push($_CONTENTS," $_PSEP $folder_name");
     if($admin) if($temp) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_EMPTY_FILE_TEMP_FOLDER,"action_delete_mini.png","",$w3->getWord(-1)."Really delete all files in temporary folder?",$w3->getWord(-1)."Empty temporary folder",0,16,16));
                else      array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_FILE_FOLDER,"action_add.png","","",$w3->getWord(264),0,16,16));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_name,$width_informations,0),array(194,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0; $total_size = 0;
     $fd = opendir($path);
     while(($file = readdir($fd)))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       if($file != "." && $file != ".." && $file != "index.html")
        {
         $link = $base_link.$id_link.$search_link.$extra_link."&file=$file";
         if($allowed) $allowed_link = $base_allowed_link."&file=$file";
         $file_size = filesize($path.$file);
         $total_size += $file_size;
		 $used = "";
		 if($pathID == WM3_cFOLDER_ECOMMERCE)   if(wm3Ecommerce::isUsedEcommercePicture($file))       $used = "<br>".wm3Util::renderimg('misc_check.png')." used";
		 if($pathID == WM3_cFOLDER_MEDIA_ALBUM) if(wm3MediaAlbum::isUsedMediaAlbumItemPicture($file)) $used = "<br>".wm3Util::renderimg('misc_check.png')." used";
		 if($pathID == WM3_cFOLDER_DOWNLOADS)   if(wm3Download::isUsedDownloadFile($file))            $used = "<br>".wm3Util::renderimg('misc_check.png')." used";
		 //TODO fare anche folder banners????
         array_push($_CONTENTS,"<a href=\"$path$file\" target=\"_blank\">$file</a>");
         array_push($_CONTENTS,"$file_size bytes $used"); 
         array_push($_WIDTHS,$width_name,$width_informations);
         if($admin) 
          {
           // Buttons
           if($temp) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FILE_TEMP_FOLDER,"action_delete.png",$w3->getWord(179),$w3->getWord(96)));
           else      array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FILE_FOLDER,"action_delete.png",$w3->getWord(179),$w3->getWord(96)));
          }
         else
          {
           if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FAQ,"action_edit.png",$w3->getWord(178)));
          }
         $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false); // TODO sostituire false con $xxxx == $currentID ????
         $p++;
        }
      }
     closedir($fd);

     // Folder total size
     $str .= wm3Section::makeItemList($w3,$p,array($width_name,$width_informations),array("<b>Folder total size:</b>","<b>".wm3Folder::renderFileSize($w3,$total_size)."</b>",""),false);

     // Create list bottom
	 $str .= wm3Section::makeBottomList($w3,$columns,'');

     return $str;
    }

   public static function getFolderSize($path)
    {
     // Get total folder size
     $size = 0;
     $fd = opendir($path);
     while(($file = readdir($fd)))
      if($file != "." && $file != ".." && $file != "index.html") $size += filesize($path.$file);
     closedir($fd);
     return $size;
    }

   public static function getFolderItems($path)
    {
     // Get total folder items
     $items = 0;
     $fd = opendir($path);
     while(($file = readdir($fd)))
      if($file != "." && $file != ".." && $file != "index.html") $items ++;
     closedir($fd); 
     return $items;
    }

   public static function addFolderFile($w3,$_ERROR = array())
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Folder::getFolderFileFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Folder::getFolderFileFieldsArray());
     for($i=1; $i <= 5; $i++) $_MSG['file'.$i] = "";
	 $pathID = $w3->getVariable('pathID','get');
	 if($pathID) { for($i = 1; $i <= 5; $i++) $_FIELD['path'.$i.'ID'] = $pathID; }

     $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
     $form_title = $w3->getWord(-1)."Upload up to 5 files";
     for($i = 1; $i <= sizeof($_ERROR); $i++)
      {
       switch($_ERROR[$i])
        {
         case 1: // File upload error
          {
           $_STYLE['file'.$i] = WM3_cSKIN_ERROR;
           $_MSG['file'.$i] = "File \"".$_FILES['file'.$i]['name']."\" upload error";
           break;
          }
         case 2: // File type error
          {
           $_STYLE['file'.$i] = WM3_cSKIN_ERROR;
           $_MSG['file'.$i] = "File \"".$_FILES['file'.$i]['name']."\" format not allowed";
           break;
          }
         case 3: // File already exist error
          {
           $_STYLE['file'.$i] = WM3_cSKIN_ERROR;
           $_MSG['file'.$i] = "File \"".$_FILES['file'.$i]['name']."\" already exists (check overwrite if you want to overwrite)";
           break;
          }
         case 4: // File uploaded successfully but overwritten
          {
           $_MSG['file'.$i] = "File \"".$_FILES['file'.$i]['name']."\" overwritten and uploaded successfully";
           break;
          }
         case 5: // File too big
          {
           $_STYLE['file'.$i] = WM3_cSKIN_ERROR;
           $_MSG['file'.$i] = "File \"".$_FILES['file'.$i]['name']."\" size too big";
           break;
          }            
         case 6: // Empty file given (no upload performed)
          {
           $_MSG['file'.$i] = "";
           break;
          }
         default: // File uploaded successfully
          {
           // Default values for the form
           $_FIELD['path'.$i.'ID']  = $w3->getVariable('path$iID','get'); // Take current pathID from get
           $_MSG['file'.$i] = "File \"".$_FILES['file'.$i]['name']."\" uploaded successfully";
     	  }
     	}
      }
     $next_action       = WM3_cACTION_UPLOAD_FILE_FOLDER;
     $next_action_label = $w3->getWord(191);
     require(WM3_cPATH_INCLUDE."admin_folder_upload_form.inc");
     return $content;
    }

   public static function checkFolderFileError($w3)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3Folder::getFolderFileFieldsArray());
     $_ARRAY = wm3Folder::getFolderFieldsArray($w3);

     $aux = time()."_".rand(1,99999); // Avoid overwritting the files
     // Upload the files and give the name to the files
     for($i=1; $i <= 5; $i++)
      {
       if($_FIELD['path'.$i.'ID'] == WM3_cFOLDER_IMG)
        $_MIME = wm3Folder::mimeTypeImage();
       if($_FIELD['path'.$i.'ID'] == WM3_cFOLDER_ECOMMERCE)
        $_MIME = wm3Folder::mimeTypeImage();
       if($_FIELD['path'.$i.'ID'] == WM3_cFOLDER_MEDIA_ALBUM)
        $_MIME = wm3Folder::mimeTypeImageAudioVideo();
       if($_FIELD['path'.$i.'ID'] == WM3_cFOLDER_DOWNLOADS)
        $_MIME = wm3Folder::mimeTypeApplicationDocument();
       $_ERROR[$i] = wm3Folder::uploadFile("file".$i,$_ARRAY['path'][$_FIELD['path'.$i.'ID']],$_FILES['file'.$i]['name'],$_FIELD['overwrite'.$i],$_MIME);
      }
     return $_ERROR; 
    }

   public static function deleteFolderFile($w3,$pathID,$temp = false)
    {
     // Delete a file from a folder
     $file = $w3->getVariable('file','get');
     if($temp) return @unlink(WM3_cPATH_TEMP.basename($file));
     else
      {
       $_ARRAY = wm3Folder::getFolderFieldsArray($w3);
       $path   = $_ARRAY['path'][$pathID];
       return @unlink($path.basename($file));
      }
    }

   public static function selectFolder($w3,$name,$pathID,$all = false)
    { 
     // Make folders select
     $_ARRAY = wm3Folder::getFolderFieldsArray($w3);
     if(!$all)
      {
       for($i = 1; $i < sizeof($_ARRAY['label']); $i++)
        {
         $_AUX['label'][$i-1]  = $_ARRAY['label'][$i];
         $_AUX['pathID'][$i-1] = $_ARRAY['pathID'][$i];
        }
       $_ARRAY = $_AUX;
      }
     return wm3Util::selectArray($name,$_ARRAY['label'],$_ARRAY['pathID'],$pathID);
    }

   public static function uploadFile($form_field,$upload_path,$upload_fname,$overwrite,$allowed = array(),$overwritted_error = 4,$max_size = 2097152)
    {
     // Upload a file using HTTP
     foreach($_FILES[$form_field] as $key => $val) $$key = $val; 

     // Check upload error
     if(!$upload_fname) return 6; // Empty or invalid file name given (no upload performed)
     if($size > $max_size || $error == 1) return 5; // File too big
     if(!is_uploaded_file($tmp_name) || $error != 0 || $size == 0) return 1; // Upload error

     // Check file type not allowed error
     if(is_array($allowed) && !empty($allowed))
      {
       if(!in_array($type,$allowed)) return 2; // File type not allowed
      }

     // Check file already exist
     if(!$overwrite)
      {
       if(file_exists($upload_path.$upload_fname)) return 3; // File already exist and overwrite off
      }

     // Move and give a name to the uploaded file
     if(file_exists($upload_path.$upload_fname)) $overwrite = true;
     $_FILES[$form_field]['name'] = $upload_fname;
     $upload_path .= $_FILES[$form_field]['name'];
     if(move_uploaded_file($tmp_name,$upload_path))
      {
       if(!$overwrite) return 0; // File uploaded successfully
       else            return $overwritted_error; // File uploaded successfully but overwritten
      }
     else return 5; // Upload error (file too big)
    }

   public static function downloadFolderFileMd5($path,$filename)
    {
     // Save a file from a folder ($filename its gived in md5 format) (N.B.: E' usato solo nella webmail!)
     $fd = opendir($path);
	 $found = false;
     while(($file = readdir($fd)))
      {
	   if(md5($file) == $filename)
        {
		 $content = file_get_contents($path.$file);
		 $found = true;
		 $_FILE = explode("_",$file,6);
		 break;
        }
      }
     closedir($fd);
	 if($found)
	  {
	   $mime_type = $_FILE[3]."/".$_FILE[4];
       header("Content-type: $mime_type"); 
       header("Content-Disposition: attachment; filename=$_FILE[5]");
       echo $content;
      }
	 die;
    }

   public static function deleteFolderFileMd5($path,$filename)
    {
     // Delete a file from a folder ($filename its gived in md5 format)
     $fd = opendir($path);
     while(($file = readdir($fd)))
      {
	   if(md5($file) == $filename)
        {
		 closedir($fd);
         return @unlink($path.basename($file));
        }
      }
     closedir($fd);
    }

   public static function deleteFolderAllFile($path,$filter = '',$timeout = 0)
    {
     // Delete all the files from a folder (using $filter as filename start string and delete all the files created before time()-$timeout)
     $fd = opendir($path);
     while(($file = readdir($fd)))
      {
	   if($filter)
	    {
         $_FILE = explode("_",$file,6);
	     if($_FILE[0] == $filter) // Deleted using filter
	      {
	       if($timeout > 0) { if(filemtime($path.basename($file)) < time()-$timeout) @unlink($path.basename($file)); }
	       else             @unlink($path.basename($file));
	      }
	    }
	   else // Delete all file
	    {
	     if($file != "." && $file != ".." && $file != "index.html")
	      {
	       if($timeout > 0) { if(filemtime($path.basename($file)) < time()-$timeout) @unlink($path.basename($file)); }
	       else             @unlink($path.basename($file));
	      }
	    }
      }
     closedir($fd);
    }

  }

?>
