<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Forum extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for forum section
     return array(
                  'allowed_section'            => WM3_cSECTION_FORUMS,
                  'allow_category_description' => true,
                  'category_form'              => 'admin_forum_category_form.inc',
                  'search_form'                => 'admin_forum_search_form.inc',
                  'table_categories'           => '_forums_categories',
                  'table_subcategories'        => '_forums',
                  'table_subcategories_count'  => '_forums',
                  'action_save_category'       => WM3_cACTION_SAVE_FORUM_CATEGORY,
                  'action_update_category'     => WM3_cACTION_UPDATE_FORUM_CATEGORY,
                  'action_show_subcategory'    => WM3_cACTION_SHOW_FORUM,
                  'action_add_subcategory'     => WM3_cACTION_ADD_FORUM,
                  'action_disable_category'    => WM3_cACTION_DISABLE_FORUM_CATEGORY,
                  'action_enable_category'     => WM3_cACTION_ENABLE_FORUM_CATEGORY,
                  'action_edit_category'       => WM3_cACTION_EDIT_FORUM_CATEGORY,
                  'action_delete_category'     => WM3_cACTION_DELETE_FORUM_CATEGORY,
                  'action_search'              => WM3_cACTION_SHOW_FORUM,
                  'label_category_list_title'  => 974,
                  'label_subcategory_add'      => 356,
                  'label_subcategories_count'  => 1757);
    }

   public static function getForumFieldsArray()
    {
     return array('forumID','title','categoryID','topic','userID','expire_days','enabled','languageID',
                  'users_read','visitors_read','users_write','visitors_write','group_open','users_open','visitors_open',
                  'denied_words','ts');
    }

   public static function getForumPostFieldsArray()
    {
     return array('postID','title','render_mode','post',
                  'discussionID','quoteID','locked','forumID','userID','replyID','unlink_quote','enabled','languageID','hits','ts');
    }

   public static function getForumPostReadFieldsArray()
    {
     return array('readID','userID','postID','read_ts');
    }

   public static function getForumPermissionsArray($w3,$forumID = 0)
    {
     // Return forum permissions array
     $_PERMISSIONS = array(
                           'forum_read'              => false,
                           'forum_write_reply'       => false,
                           'forum_open_discussion'   => false,
						   'forum_edit_discussion'   => false,
						   'forum_lock_discussion'   => false,
                           'forum_delete_discussion' => false,
						   'forum_edit_reply'        => false,
						   'forum_delete_reply'      => false						   
                          );
     if($forumID == 0) $forumID = $w3->getVariable('forumID','both');
     $rs = wm3Sql::sqlQuery("SELECT ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled,
	                                ".WM3_cCONFIG_DB_PREFIX."_forums.*
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_forums,
							        ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_forums.categoryID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums.enabled*".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled='".WM3_cENABLED."'
							   AND  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = '$forumID'");
     if(mysql_num_rows($rs) != 1) return $_PERMISSIONS;
     $row = mysql_fetch_object($rs); 

	 // Set visitors permissions (no user logged)
     $_PERMISSIONS['forum_read']              = $row->visitors_read;
     $_PERMISSIONS['forum_write_reply']       = $row->visitors_write;
     $_PERMISSIONS['forum_open_discussion']   = $row->visitors_open;
	 $_PERMISSIONS['forum_edit_discussion']   = false;
	 $_PERMISSIONS['forum_lock_discussion']   = false;
     $_PERMISSIONS['forum_delete_discussion'] = false;
	 $_PERMISSIONS['forum_edit_reply']        = false;
	 $_PERMISSIONS['forum_delete_reply']      = false;

     // Set user or administrator permissions (user or administrator logged)
     if($w3->getAuthenticateAdminUserID())
      {
       $_PERMISSIONS['forum_read']              = $row->users_read;
       $_PERMISSIONS['forum_write_reply']       = $row->users_write;
       $_PERMISSIONS['forum_open_discussion']   = $row->users_open;

	   // If logged user/administrator group its the same of moderator group
       if(wm3User::getGroupID($w3->getAuthenticateAdminUserID()) == wm3User::getGroupID($row->userID))
	    {
         $_PERMISSIONS['forum_read']              = true;
         $_PERMISSIONS['forum_write_reply']       = true;
         $_PERMISSIONS['forum_open_discussion']   = $row->group_open;
	    }
	   // If logged user/administrator its moderator
       if($w3->getAuthenticateAdminUserID() == $row->userID)
	    {
         $_PERMISSIONS['forum_read']              = true;
         $_PERMISSIONS['forum_write_reply']       = true;
         $_PERMISSIONS['forum_open_discussion']   = true;
	     $_PERMISSIONS['forum_edit_discussion']   = true;
		 $_PERMISSIONS['forum_lock_discussion']   = true;
         $_PERMISSIONS['forum_delete_discussion'] = true;
    	 $_PERMISSIONS['forum_edit_reply']        = true;
	     $_PERMISSIONS['forum_delete_reply']      = true;
	    }
	   // If administrator can manage forums (and manage users ??? TODO poich se gestisce gli utenti puo' mettersi il permesso di gestire il forum)
       if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS))
	    {
         $_PERMISSIONS['forum_read']              = true;
         $_PERMISSIONS['forum_write_reply']       = true;
         $_PERMISSIONS['forum_open_discussion']   = true;
         $_PERMISSIONS['forum_edit_discussion']   = true;		 		 
		 $_PERMISSIONS['forum_lock_discussion']   = true;
         $_PERMISSIONS['forum_delete_discussion'] = true;
    	 $_PERMISSIONS['forum_edit_reply']        = true;
	     $_PERMISSIONS['forum_delete_reply']      = true;
		}
      }
     return $_PERMISSIONS;
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Forum page content
     $_PERMISSIONS = wm3Forum::getForumPermissionsArray($w3); // Get forum permissions
	 wm3Forum::expireForumDiscussions($w3); // Expire old discussions
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FORUM_QUOTE:
        {
		 // Check if an user try to quote in an invalid forumID/postID
	     if($w3->getVariable('postID','both') == $w3->getVariable('quoteID','both')) $postID = 0; // Try to quote a discussion
	     else  $postID = $w3->getVariable('postID','both');
	     $check = wm3Forum::existsForumReply($w3->getVariable('forumID','both'),$postID,$w3->getVariable('quoteID','both'));

         if($_PERMISSIONS['forum_write_reply'] && $check && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID','both'))) return wm3Forum::addForumQuote($w3);
         else                                                                                                                          return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_SAVE_FORUM_QUOTE:
        {
         if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID','both')))
          {
           wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_users             WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $error = wm3Forum::checkForumQuoteError($w3);
           if(!$error) {
                        $lastID = wm3Forum::saveForumQuote($w3);
                        wm3Sql::sqlQuery("UNLOCK TABLES");
                        return wm3Forum::renderForumReplies($w3,$lastID,$_PERMISSIONS);
                       }
           else        {
			            wm3Sql::sqlQuery("UNLOCK TABLES");
			            return wm3Forum::addForumQuote($w3,$error);
					   }
          }
         else return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_ADD_FORUM_REPLY:
        {
         if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID','both'))) return wm3Forum::addForumReply($w3);
         else                                                                                                                return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_SAVE_FORUM_REPLY:
        {
         if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID','both')))
          {
           wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_users             WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $error = wm3Forum::checkForumReplyError($w3);
           if(!$error) {
                        $lastID = wm3Forum::saveForumReply($w3);
                        wm3Sql::sqlQuery("UNLOCK TABLES");
                        return wm3Forum::renderForumReplies($w3,$lastID,$_PERMISSIONS);
                       }
           else        {
			            wm3Sql::sqlQuery("UNLOCK TABLES");
			            return wm3Forum::addForumReply($w3,$error);
                       }
		  }
         else return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_EDIT_FORUM_REPLY:
        {
         if($_PERMISSIONS['forum_write_reply'] && $_PERMISSIONS['forum_edit_reply']) return wm3Forum::editForumReply($w3);
         else                                                                        return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_UPDATE_FORUM_REPLY:
        {
         if($_PERMISSIONS['forum_write_reply'] && $_PERMISSIONS['forum_edit_reply'])
          {
           wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $error = wm3Forum::checkForumReplyError($w3);
           if(!$error) {
                        $lastID = wm3Forum::updateForumReply($w3);
                        wm3Sql::sqlQuery("UNLOCK TABLES");
                        return wm3Forum::renderForumReplies($w3,$lastID,$_PERMISSIONS);
                       }
           else        {
			            wm3Sql::sqlQuery("UNLOCK TABLES");
			            return wm3Forum::editForumReply($w3,$error);
                       }
		  }
         else return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_DELETE_FORUM_REPLY:
	    {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_delete_reply'])
		  {
           wm3Forum::deleteForumReply($w3,$w3->getVariable('replyID','both'));
           return wm3Forum::renderForumReplies($w3,0,$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
		}
       case WM3_cACTION_ADD_FORUM_DISCUSSION:
        {
         if($_PERMISSIONS['forum_open_discussion']) return wm3Forum::addForumDiscussion($w3);
         else                                       return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_SAVE_FORUM_DISCUSSION:
        {
         if($_PERMISSIONS['forum_open_discussion'])
          {
           wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $error = wm3Forum::checkForumDiscussionError($w3);
           if(!$error) {
                        $lastID = wm3Forum::saveForumDiscussion($w3);
                        wm3Sql::sqlQuery("UNLOCK TABLES");
                        return wm3Forum::renderForumDiscussions($w3,$lastID,$_PERMISSIONS);
                       }
           else        {
			            wm3Sql::sqlQuery("UNLOCK TABLES");
			            return wm3Forum::addForumDiscussion($w3,$error);
					   }
          }
         else return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_EDIT_FORUM_DISCUSSION:
        {
         if($_PERMISSIONS['forum_open_discussion'] && $_PERMISSIONS['forum_edit_discussion']) return wm3Forum::editForumDiscussion($w3);
         else                                                                                 return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_UPDATE_FORUM_DISCUSSION:
        {
         if($_PERMISSIONS['forum_open_discussion'] && $_PERMISSIONS['forum_edit_discussion'])
          {
           wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $error = wm3Forum::checkForumDiscussionError($w3,true);
           if(!$error) {
                        $lastID = wm3Forum::updateForumDiscussion($w3);
                        wm3Sql::sqlQuery("UNLOCK TABLES");
                        return wm3Forum::renderForumDiscussions($w3,$lastID,$_PERMISSIONS);
                       }
           else        {
			            wm3Sql::sqlQuery("UNLOCK TABLES");
			            return wm3Forum::editForumDiscussion($w3,$error);
					   }
          }
         else return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_LOCK_FORUM_DISCUSSION:
        {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_lock_discussion'])
		  {
           wm3Forum::lockForumDiscussion($w3,$w3->getVariable('postID','both'));
           return wm3Forum::renderForumDiscussions($w3,$w3->getVariable('postID','both'),$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_UNLOCK_FORUM_DISCUSSION:
	    {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_lock_discussion'])
		  {
           wm3Forum::unlockForumDiscussion($w3,$w3->getVariable('postID','both'));
           return wm3Forum::renderForumDiscussions($w3,$w3->getVariable('postID','both'),$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
		}
       case WM3_cACTION_DELETE_FORUM_DISCUSSION:
	    {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_delete_discussion'])
		  {
           wm3Forum::deleteForumDiscussion($w3,$w3->getVariable('postID','both'));
           return wm3Forum::renderForumDiscussions($w3,$w3->getVariable('postID','both'),$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
		}
       case WM3_cACTION_SHOW_FORUM_REPLIES:
        {
         if($_PERMISSIONS['forum_read']) return wm3Forum::renderForumReplies($w3,$w3->getVariable('replyID','both'),$_PERMISSIONS);
         else                            return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_SHOW_FORUM_DISCUSSIONS:
        {
         if($_PERMISSIONS['forum_read']) return wm3Forum::renderForumDiscussions($w3,0,$_PERMISSIONS);
         else                            return wm3Forum::renderForumDenied($w3);
         break;
        }
	   case WM3_cACTION_SEARCH_FORUM:
        {
         return wm3Forum::renderForumSearch($w3,0,$_PERMISSIONS);
         break;
        }	
       default:
        {
         return wm3Forum::renderForumCompleteList($w3);
        }
      }
    }

   public static function executeUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FORUM:
        {
         return wm3Forum::addForum($w3,0,true);
         break;
        }
       case WM3_cACTION_SAVE_FORUM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE");
         $error = wm3Forum::checkForumError($w3);
         if(!$error) {
                      $lastID = wm3Forum::saveForum($w3,true);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Forum::getForumList($w3,$lastID,true,true);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Forum::addForum($w3,$error,true);
				     }
         break;
        }
       case WM3_cACTION_EDIT_FORUM:
        {
         return wm3Forum::editForum($w3,0,true);
         break;
        }
       case WM3_cACTION_UPDATE_FORUM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE");	
         $error = wm3Forum::checkForumError($w3);
         if(!$error) {
                      $lastID = wm3Forum::updateForum($w3,true);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Forum::getForumList($w3,$lastID,true,true);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Forum::editForum($w3,$error,true);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_FORUM:
        {
         wm3Forum::disableForum($w3,$w3->getVariable('forumID','get'),true);
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'),true,true);
         break;
        }
       case WM3_cACTION_ENABLE_FORUM:
        {
         wm3Forum::enableForum($w3,$w3->getVariable('forumID','get'),true);
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'),true,true);
         break;
        }
       case WM3_cACTION_DELETE_FORUM:
        {
         wm3Forum::deleteForum($w3,$w3->getVariable('forumID','get'),true);
         return wm3Forum::getForumList($w3,0,true,true);
         break;
        }
       default:
        {
         return wm3Forum::getForumList($w3,0,true,true);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FORUM_CATEGORY:
        {
         return wm3Forum::addForumCategory($w3);
         break;
        }
       case WM3_cACTION_SAVE_FORUM_CATEGORY:
        {
         $error = wm3Forum::checkForumCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Forum::saveForumCategory($w3);
           // $msg= message saved... //TODO
           return wm3Forum::getForumCategoryList($w3,$lastID);
          }
         else return wm3Forum::addForumCategory($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_FORUM_CATEGORY:
        {
         return wm3Forum::editForumCategory($w3);
         break;
        }
       case WM3_cACTION_UPDATE_FORUM_CATEGORY:
        {
         $error = wm3Forum::checkForumCategoryError($w3);
         if(!$error)
          {
           $lastID = wm3Forum::updateForumCategory($w3);
           // $msg= message udated... //TODO
           return wm3Forum::getForumCategoryList($w3,$lastID);
          }
         else return wm3Forum::editForumCategory($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_FORUM_CATEGORY:
        {
         wm3Forum::disableForumCategory($w3->getVariable('categoryID','get'));
         return wm3Forum::getForumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_FORUM_CATEGORY:
        {
         wm3Forum::enableForumCategory($w3->getVariable('categoryID','get'));
         return wm3Forum::getForumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_FORUM_CATEGORY:
        {
         wm3Forum::deleteForumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Forum::getForumCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_FORUM:
        {
         return wm3Forum::addForum($w3);
         break;
        }
       case WM3_cACTION_SAVE_FORUM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE");
         $error = wm3Forum::checkForumError($w3);
         if(!$error) {
                      $lastID = wm3Forum::saveForum($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Forum::getForumList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Forum::addForum($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_EDIT_FORUM:
        {
         return wm3Forum::editForum($w3);
         break;
        }
       case WM3_cACTION_UPDATE_FORUM:
        {
		 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE");
         $error = wm3Forum::checkForumError($w3);
         if(!$error) {
                      $lastID = wm3Forum::updateForum($w3);
                      wm3Sql::sqlQuery("UNLOCK TABLES");
                      return wm3Forum::getForumList($w3,$lastID);
                     }
         else        {
			          wm3Sql::sqlQuery("UNLOCK TABLES");
			          return wm3Forum::editForum($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_FORUM:
        {
         wm3Forum::disableForum($w3,$w3->getVariable('forumID','get'));
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_FORUM:
        {
         wm3Forum::enableForum($w3,$w3->getVariable('forumID','get'));
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'));
         break;
        }
       case WM3_cACTION_DELETE_FORUM:
        {
         wm3Forum::deleteForum($w3,$w3->getVariable('forumID','get'));
         return wm3Forum::getForumList($w3);
         break;
        }
       case WM3_cACTION_ADD_CHATROOM:
        {
         return wm3Chatroom::addChatroom($w3);
         break;
        }
       case WM3_cACTION_SAVE_CHATROOM:
        {
         $error = wm3Chatroom::checkChatroomError($w3);
         if(!$error)
          {
           $lastID = wm3Chatroom::saveChatroom($w3);
           // $msg= forum saved... //TODO
           return wm3Chatroom::getChatroomList($w3,$lastID);
          }
         else return wm3Chatroom::addChatroom($w3,$error);
         break;
        }
       case WM3_cACTION_EDIT_CHATROOM:
        {
         return wm3Chatroom::editChatroom($w3);
         break;
        }
       case WM3_cACTION_UPDATE_CHATROOM:
        {
         $error = wm3Chatroom::checkChatroomError($w3);
         if(!$error)
          {
           $lastID = wm3Chatroom::updateChatroom($w3);
           // $msg= message udated... //TODO
           return wm3Chatroom::getChatroomList($w3,$lastID);
          }
         else return wm3Chatroom::editChatroom($w3,$error);
         break;
        }
       case WM3_cACTION_DISABLE_CHATROOM:
        {
         wm3Chatroom::disableChatroom($w3->getVariable('chatroomID','get'));
         return wm3Chatroom::getChatroomList($w3,$w3->getVariable('chatroomID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHATROOM:
        {
         wm3Chatroom::enableChatroom($w3->getVariable('chatroomID','get'));
         return wm3Chatroom::getChatroomList($w3,$w3->getVariable('chatroomID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHATROOM:
        {
         wm3Chatroom::deleteChatroom($w3->getVariable('chatroomID','get'));
         return wm3Chatroom::getChatroomList($w3);
         break;
        }
	   case WM3_cACTION_SHOW_CHATROOM:
	    {
		 return wm3Chatroom::getChatroomList($w3);
		 break;
		}
       case WM3_cACTION_SHOW_FORUM:
        {
         return wm3Forum::getForumList($w3);
         break;
        }
       default:
        {
         return wm3Forum::getForumCategoryList($w3);
        }
      }     
    }

   public static function renderForumDenied($w3)
    {
     // Give a denied access message (home side)

     // Prepare variables to create the content
     $forumID = $w3->getVariable('forumID','both');
     $postID  = $w3->getVariable('postID','both');
     $pg = $w3->getVariable('pg','both');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND forumID = '$forumID' AND discussionID = '$postID' OR postID = '$postID'";
     $columns = 1; $buttons = 0;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID','both');
     $id_link   = "&forumID=$forumID";

     // Create list header
     $str = wm3Forum::renderForumHeader($w3,$forumID,$columns,false,"","",true,true);

     // List items
     $_CONTENTS = array(); $_WIDTHS = array();
     $link = $base_link.$id_link.$page_link.$search_link.$extra_link;//."&postID=$row->postID";
     $message = "<div align=\"center\"><br><img src=\"".WM3_cPATH_DATA."misc_stop.png\" border=\"0\" width=\"40\" height=\"37\"><br><br><b>Access denied!</b><br><br>You can not perform this action for this forum.</div><br>";
     array_push($_CONTENTS,$message); array_push($_WIDTHS,100);
     $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false);

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderForumCompleteList($w3)
    {
     // Render complete category forum and forum list (for forum page content) 

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $filter       = $w3->getVariable('filter','both'); // Search field
	 $filter_check = $w3->getVariable('filter_check','both');
	 $forumID = 0; // Used in search form
     $query_filter = "WHERE enabled='".WM3_cENABLED."' AND (languageID='".$w3->getHomeLanguage()."' OR languageID='".WM3_cLANGUAGE_ALL."')";
     if($allowed) { $columns = 7; $buttons = 1; } else { $columns = 6; $buttons = 0; }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FORUMS;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
	 $page_link = "&pageID=".$w3->getVariable('pageID','both');
     $id_link = "";

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Create list header
     $_CONTENTS = array();
	 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SEARCH_FORUM.$page_link;
     require(WM3_cPATH_INCLUDE."home_forum_search_form.inc");    
     array_push($_CONTENTS,$w3->getWord(992));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     $_WIDTHS   = array(0,54,5,5,18,18);
     $_CONTENTS = array(1261,-1,984,1329,1398,1399);
     if($allowed) { array_push($_WIDTHS,0); array_push($_CONTENTS,-1); }
     $str .= wm3Section::makeCaptionList($w3,$_WIDTHS,$_CONTENTS,$buttons,true);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // List items
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link."&categoryID=$row->categoryID";
       if($allowed) $allowed_link = $base_allowed_link."&categoryID=$row->categoryID";

       $icon = "<img src=\"".WM3_cPATH_ICONS."$row->icon\" width=\"36\" height=\"36\" border=\"0\">";
       $name = "$row->name<br>$row->description";
       array_push($_CONTENTS,$icon,$name);
       array_push($_WIDTHS,0,100);

       if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FORUM_CATEGORY,"action_edit.png",$w3->getWord(178)));
       $str .= wm3Section::makeItemList($w3,0,$_WIDTHS,$_CONTENTS,false,array(0,$columns-1-$buttons),true);
       
       $str .= wm3Forum::renderForumList($w3,$row->categoryID);
      }

     // Create list bottom
     $str .= wm3Section::makeBottomList($w3,$columns);

     return $str;
    }

   public static function renderForumList($w3,$categoryID)
    {
     // Render forums list for a category (for forum page content) 

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $query_filter = "WHERE enabled='".WM3_cENABLED."' AND categoryID='$categoryID' AND (languageID='".$w3->getHomeLanguage()."' OR languageID='".WM3_cLANGUAGE_ALL."')";
     if($allowed) { $columns = 7; $buttons = 1; } else { $columns = 6; $buttons = 0; }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FORUMS;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID','get');
     $id_link = "";

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return wm3Section::makeEmptyItemsList($w3,$columns,593,true);

     // List items
     $p = 0; $str = "";
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$page_link."&forumID=$row->forumID";
       if($allowed) $allowed_link = $base_allowed_link."&forumID=$row->forumID";
       
       $icon  = "";//<img src=\"".WM3_cPATH_ICONS."$row->icon\" width=\"36\" height=\"36\" border=\"0\">";
       $forum = "<a href=\"$link&action=".WM3_cACTION_SHOW_FORUM_DISCUSSIONS."\">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a><br>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>Created ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       $discussions = wm3Forum::countForumDiscussions($row->forumID);
       $replies     = wm3Forum::countForumReplies($row->forumID);
	   $last_discussionID       = wm3Forum::getLastDiscussionID($row->forumID);
	   $last_replyID            = wm3Forum::getLastForumReplyID($row->forumID);
	   $last_reply_discussionID = wm3Forum::getLastReplyDiscussionID($last_replyID);
       $last_discussion = wm3Forum::renderForumPostDate($w3,$last_discussionID);
       $last_reply      = wm3Forum::renderForumPostDate($w3,$last_replyID);
	   if($last_discussion != "-") $last_discussion .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_discussionID)." ".wm3Util::actionButton("$link&postID=$last_discussionID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
       if($last_reply != "-")      $last_reply      .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_replyID)." ".wm3Util::actionButton("$link&postID=$last_reply_discussionID&replyID=$last_replyID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
	   array_push($_CONTENTS,$icon,$forum,$discussions,$replies,$last_discussion,$last_reply);
       array_push($_WIDTHS,0,54,5,5,18,18,0);

       if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FORUM,"action_edit.png",$w3->getWord(178)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,false);
       $p++;
      }

     return $str;
    }

   public static function renderForumDiscussions($w3,$currentID,$_PERMISSIONS)
    {
     // Get discussion for a forum (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
	 $no_button = true;	 
     $buttons = $_PERMISSIONS['forum_edit_discussion'] + $_PERMISSIONS['forum_lock_discussion'] + $_PERMISSIONS['forum_delete_discussion'];
	 $columns = 6 + $buttons;
     $forumID = $w3->getVariable('forumID','both');
     $pg = $w3->getVariable('pg','both');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND forumID='$forumID' AND discussionID = '0'";
     
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID','both');
     $id_link   = "&forumID=$forumID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                        $query_filter";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'postID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     if($_PERMISSIONS['forum_open_discussion']) $button_discussion = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link."&action=".WM3_cACTION_ADD_FORUM_DISCUSSION,"action_add.png","","",$w3->getWord(1024),0,16,16);
     else                                       $button_discussion = "";
     $str = wm3Forum::renderForumHeader($w3,$forumID,$columns,false,$button_discussion);

     // Create list caption
     $_WIDTHS   = array(0,56,15,2,2,25); $_CONTENTS = array(-1,984,1328,1329,1619,1399);
     if($buttons) { array_push($_WIDTHS,0); array_push($_CONTENTS,-1); $no_button = false; }
     $str .= wm3Section::makeCaptionList($w3,$_WIDTHS,$_CONTENTS,$buttons,$no_button);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // List items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
	   $link = $base_link.$page_link.$id_link.$search_link."&postID=$row->postID";

       $replies = wm3Forum::countForumDiscussionReplies($row->forumID,$row->postID);
	   if($replies >= 25)                                    $hot  = true;  else $hot  = false;
       if($row->locked)                                      $lock = true;  else $lock = false;
	   if(wm3Forum::isForumDiscussionRead($w3,$row->postID)) $new  = false; else $new  = true;
	   $icon       = $w3->getSkinObj()->getForumIcon($hot,$lock,$new);
       $title      = "<a href=\"$link&action=".WM3_cACTION_SHOW_FORUM_REPLIES."\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       $author     = wm3User::getUserLogin($row->userID); if(!$author) $author = $w3->getWord(988);
       $hits       = $row->hits;

	   $last_replyID = wm3Forum::getLastDiscussionReplyID($row->postID);
       $last_reply   = wm3Forum::renderForumPostDate($w3,$last_replyID);
       if($last_reply != "-") $last_reply .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_replyID)." ".wm3Util::actionButton("$link&replyID=$last_replyID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
	   
       array_push($_CONTENTS,$icon,$title,$author,$replies,$hits,$last_reply);
       array_push($_WIDTHS,0,56,15,2,2,25,0);
       // Buttons
       if($_PERMISSIONS['forum_edit_discussion']) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_DISCUSSION,"action_edit.png",$w3->getWord(178)));
       if($_PERMISSIONS['forum_lock_discussion'])
		{
         if($row->locked) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_UNLOCK_FORUM_DISCUSSION,"action_unlock.png",$w3->getWord(1624)));
         else             array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_LOCK_FORUM_DISCUSSION,"action_lock.png",$w3->getWord(1623)));
	    }
       if($_PERMISSIONS['forum_delete_discussion']) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FORUM_DISCUSSION,"action_delete.png",$w3->getWord(179),$w3->getWord(1016)));
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->postID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_FORUM_DISCUSSIONS.$id_link.$search_link);
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function lockForumDiscussion($w3,$postID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET locked = '".WM3_cENABLED."' WHERE postID = '$postID' AND discussionID='0'");
	}

   public static function unlockForumDiscussion($w3,$postID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET locked = '".WM3_cDISABLED."' WHERE postID = '$postID' AND discussionID='0'");
	}

   public static function deleteForumDiscussion($w3,$postID)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
  	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WHERE postID = '$postID'");
 	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE discussionID = '$postID'");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE postID = '$postID' AND discussionID = '0'");
     wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function renderForumReplies($w3,$currentID,$_PERMISSIONS)
    {
     // Get replies for a discussion in a forum (home side)

     // Prepare variables to create the list
     $max_page_items = 12;

	 $no_button = true;	 
     $buttons = $_PERMISSIONS['forum_edit_reply'] + $_PERMISSIONS['forum_delete_reply'];
	 $columns = 6 + $buttons;
     $forumID = $w3->getVariable('forumID','both');
     $postID  = $w3->getVariable('postID','both'); if(!$postID) $postID = 0;
     $pg = $w3->getVariable('pg','both');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     if($filter)//TODO la ricerca (ed i filtri) qui servono??? si usano???
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ""; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND ((forumID = '$forumID' AND discussionID = '$postID') OR (forumID='$forumID' AND postID = '$postID')) AND 0 = (SELECT discussionID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE postID='$postID' AND discussionID = '0') AND $postID > 0";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID','both');
     $id_link   = "&forumID=$forumID&postID=$postID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                        $query_filter";					
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'postID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     if($_PERMISSIONS['forum_open_discussion']) $button_discussion = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link.$extra_link."&action=".WM3_cACTION_ADD_FORUM_DISCUSSION,"action_add.png","","",$w3->getWord(1024),0,16,16);
     else                                       $button_discussion = "";
     if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$postID)) $button_reply = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link.$extra_link."&action=".WM3_cACTION_ADD_FORUM_REPLY,"action_add.png","","",$w3->getWord(1025),0,16,16);
     else                                                                                      $button_reply = "";
     $str = wm3Forum::renderForumHeader($w3,$forumID,$columns,false,$button_discussion,$button_reply);

     // Create list caption
     $_WIDTHS   = array(0,100); $_CONTENTS = array(1328,1618);
     if($buttons) { array_push($_WIDTHS,0); array_push($_CONTENTS,-1); $no_button = false; }
     $str .= wm3Section::makeCaptionList($w3,$_WIDTHS,$_CONTENTS,$buttons,$no_button);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // List items
     wm3Forum::setForumDiscussionRead($w3,$postID);
	 wm3Forum::hitForumDiscussion($w3);
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$page_link.$search_link.$extra_link."&replyID=$row->postID";
       if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$postID)) $quote_button = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link.$extra_link."&quoteID=$row->postID&action=".WM3_cACTION_ADD_FORUM_QUOTE,"action_add.png","","",$w3->getWord(1578),0,16,16);
       else                                                                                      $quote_button = "";

       $user_rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                    WHERE userID = '$row->userID'");
       if(mysql_num_rows($user_rs) == 1)
        {
         $user_row = mysql_fetch_object($user_rs);
         $user_info = wm3Util::renderImg($user_row->avatar,'',36,36,WM3_cPATH_AVATARS,1)."<br>".wm3Util::makeLink($w3,WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_USER_INFORMATIONS."&userID=$user_row->userID",$user_row->login);
        }
       else $user_info = wm3Util::renderImg('misc_anonymous.png','',36,36,WM3_cPATH_DATA,1)."<br>".$w3->getWord(988);

       $post_date  = wm3Forum::renderForumPostDate($w3,$row->postID);
       if($row->quoteID) $quote_text = wm3Forum::renderForumQuoteText($w3,$row->quoteID);
       else              $quote_text = "";
	   $post = wm3Util::renderContent($w3,$row->post,$row->render_mode);
       if($p == 0) $reply = "<i>$post_date</i> $quote_button<br><br><b>".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</b><br><br>".$quote_text.$post; // Discussion
       else        $reply = "<i>$post_date</i> $quote_button<br><br>".$quote_text.$post;                                                                             // Replies
       array_push($_CONTENTS,$user_info,$reply);
       array_push($_WIDTHS,0,100,0);

       // Buttons
       if($row->discussionID != 0) // Normal reply
	    {
         if($_PERMISSIONS['forum_edit_reply'])   array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_REPLY,"action_edit.png",$w3->getWord(178)));
         if($_PERMISSIONS['forum_delete_reply']) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FORUM_REPLY,"action_delete.png",$w3->getWord(179),$w3->getWord(1017)));
	    }
	   else // Discussion
	    {
		 if($buttons > 0)
		  {
		   if($_PERMISSIONS['forum_edit_discussion']) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_DISCUSSION,"action_edit.png",$w3->getWord(178)));
		   else                                       array_push($_CONTENTS,wm3Util::renderImg("action_edit_inactive.png",'',24,24,WM3_cPATH_DATA));
		   if($_PERMISSIONS['forum_delete_discussion']) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FORUM_DISCUSSION,"action_delete.png",$w3->getWord(179),$w3->getWord(1016)));
		   else                                         array_push($_CONTENTS,wm3Util::renderImg("action_delete_inactive.png",'',24,24,WM3_cPATH_DATA));
	      }
		}
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->postID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link.$id_link."&action=".WM3_cACTION_SHOW_FORUM_REPLIES.$search_link);
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function renderForumSearch($w3,$currentID,$_PERMISSIONS)
    {
     // Render a forum search (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $columns = 9; $buttons = 3;
     $forumID = $w3->getVariable('forumID','both');
     $pg = $w3->getVariable('pg','both');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $filter       = $w3->getVariable('filter','both'); // Search field
	 $filter_check = $w3->getVariable('filter_check','both');
     if($filter)
      {
       $search_link  = "&filter=$filter";   
       $query_filter = " AND (".WM3_cCONFIG_DB_PREFIX."_forums_posts.title LIKE '%$filter%' OR post LIKE '%$filter%')";
	   if($filter_check) 
	    {
		 $search_link  .= "&filter_check=$filter_check";
		 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '0' ";
		}	
      }
     else { $search_link = ""; $query_filter = " AND 1 = 0 "; }
	 if($forumID) $query_filter .= "AND ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = '$forumID'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID','both');
     $id_link   = "&forumID=$forumID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled,
	                  ".WM3_cCONFIG_DB_PREFIX."_forums.enabled,
	                  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.*
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_forums_categories,
			          ".WM3_cCONFIG_DB_PREFIX."_forums,
					  ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	           WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_forums.categoryID
			     AND  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID
				 AND  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_forums.enabled*".WM3_cCONFIG_DB_PREFIX."_forums_posts.enabled='".WM3_cENABLED."'
				 AND  (".WM3_cCONFIG_DB_PREFIX."_forums.languageID = '".WM3_cLANGUAGE_ALL."'
				  OR   ".WM3_cCONFIG_DB_PREFIX."_forums.languageID = '".$w3->getHomeLanguage()."')
				 AND  (".WM3_cCONFIG_DB_PREFIX."_forums_categories.languageID = '".WM3_cLANGUAGE_ALL."'
				  OR   ".WM3_cCONFIG_DB_PREFIX."_forums_categories.languageID = '".$w3->getHomeLanguage()."')
               $query_filter";

     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'postID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $str = wm3Forum::renderForumHeader($w3,$forumID,$columns,false,'','',false,true,true,$total_items);

     // Create list caption
     $_WIDTHS   = array(0,56,15,2,2,25,0); $_CONTENTS = array(-1,984,1328,1329,1619,1399,-1);
     $str .= wm3Section::makeCaptionList($w3,$_WIDTHS,$_CONTENTS,$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // List items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
	   $link = $base_link.$page_link.$id_link."&forumID=$row->forumID"."&postID=$row->postID";

       if(!$forumID) $_PERMISSIONS = wm3Forum::getForumPermissionsArray($w3,$row->forumID);
       if($_PERMISSIONS['forum_read'])
	    {
         if($row->discussionID == 0) // Show a discussion
	      {
           $replies = wm3Forum::countForumDiscussionReplies($row->forumID,$row->postID);
	       if($replies >= 25)                                    $hot  = true;  else $hot  = false;
           if($row->locked)                                      $lock = true;  else $lock = false;
	       if(wm3Forum::isForumDiscussionRead($w3,$row->postID)) $new  = false; else $new  = true;
	       $icon       = $w3->getSkinObj()->getForumIcon($hot,$lock,$new);
           $post       = "<a href=\"$link&action=".WM3_cACTION_SHOW_FORUM_REPLIES."\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
           $hits       = $row->hits;
	       $last_replyID = wm3Forum::getLastDiscussionReplyID($row->postID);
           $last_reply   = wm3Forum::renderForumPostDate($w3,$last_replyID);
           if($last_reply != "-") $last_reply .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_replyID)." ".wm3Util::actionButton("$link&replyID=$last_replyID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
	      }
	     else // Show a normal post
	      {
		   $icon = "";
		   $replies = $title = $hits = $last_reply = "-";
		   $post = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage())."[".wm3Util::actionButton("$link&postID=$row->discussionID&replyID=$row->postID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]<br><br>".wm3Util::renderContent($w3,$row->post,$row->render_mode);
          }
		 $author = wm3User::getUserLogin($row->userID); if(!$author) $author = $w3->getWord(988);
	    }
	   else
	    {
		 $icon = "";
		 $author = $replies = $hits = $last_reply = "-";
		 $post = wm3Util::renderImg("misc_error_mini.png")." You can not read this post<br><br>";
		}
       array_push($_CONTENTS,$icon,$post,$author,$replies,$hits,$last_reply);
       array_push($_WIDTHS,0,56,15,2,2,25,0);

       // Buttons
       if($row->discussionID == 0)
	    {
         if($_PERMISSIONS['forum_lock_discussion'])
	      {
           if($row->locked) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_UNLOCK_FORUM_DISCUSSION,"action_unlock.png",$w3->getWord(1624)));
           else             array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_LOCK_FORUM_DISCUSSION,"action_lock.png",$w3->getWord(1623)));
	      }
		 else array_push($_CONTENTS,'');
         if($_PERMISSIONS['forum_edit_discussion'])   array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_DISCUSSION,"action_edit.png",$w3->getWord(178)));                        else array_push($_CONTENTS,'');
         if($_PERMISSIONS['forum_delete_discussion']) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FORUM_DISCUSSION,"action_delete.png",$w3->getWord(179),$w3->getWord(1016))); else array_push($_CONTENTS,'');
	    }
       else
	    {
	     array_push($_CONTENTS,'');
	     if($_PERMISSIONS['forum_edit_reply'])   array_push($_CONTENTS,wm3Util::actionButton("$link&postID=$row->discussionID&replyID=$row->postID&action=".WM3_cACTION_EDIT_FORUM_REPLY,"action_edit.png",$w3->getWord(178)));                        else array_push($_CONTENTS,'');
	     if($_PERMISSIONS['forum_delete_reply']) array_push($_CONTENTS,wm3Util::actionButton("$link&postID=$row->discussionID&replyID=$row->postID&action=".WM3_cACTION_DELETE_FORUM_REPLY,"action_delete.png",$w3->getWord(179),$w3->getWord(1017))); else array_push($_CONTENTS,'');
	    }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->postID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SEARCH_FORUM.$id_link.$search_link);
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function deleteForumReply($w3,$postID)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE");
	 wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE postID = '$postID' AND discussionID != '0'");
     wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function checkForumQuoteError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     if($_FIELD['post']=='') return 1;
	 if($_FIELD['postID'] == $_FIELD['quoteID']) $_FIELD['postID'] = 0; // Try to quote a discussion
	 if(!wm3Forum::existsForumReply($_FIELD['forumID'],$_FIELD['postID'],$_FIELD['quoteID'])) return 2;
     return 0;
    }

   public static function checkForumReplyError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     if($_FIELD['post']=='') return 1;
	 if(!wm3Forum::existsForumDiscussion($_FIELD['forumID'],$_FIELD['postID'])) return 2;
     return 0;
    }

   public static function checkForumDiscussionError($w3,$update = false)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     if($_FIELD['title']=='') return 1;
     if($_FIELD['post']=='')  return 2;
	 if(!wm3Forum::existsForum($_FIELD['forumID'])) return 3;
	 if($update) if(!wm3Forum::isForumDiscussion($w3,$_FIELD['postID'])) return 4;
     return 0;
    }

   public static function addForumQuote($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Forum::getForumPostFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";

     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID','both'),1,true);

     switch($error)
      {
       case 1: // No post
        {
         $_STYLE['post']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       case 2: // Invalid discussion or reply
        {
         //$_STYLE['post']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid discussion or reply";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['forumID']     = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['render_mode'] = WM3_cRENDER_MODE_BB_CODE;
		 $_FIELD['enabled']     = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1578);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_FORUM_QUOTE;
     $next_action_label = $w3->getWord(191);
     $_FIELD['pageID']  = $w3->getVariable('pageID','both');
     $_FIELD['forumID'] = $w3->getVariable('forumID','both');
     $_FIELD['postID']  = $w3->getVariable('postID','both');
     $_FIELD['quoteID'] = $w3->getVariable('quoteID','both');
     $quote_text = wm3Forum::renderForumQuoteText($w3,$_FIELD['quoteID']);
     require(WM3_cPATH_INCLUDE."home_forum_quote_form.inc");
     return $str.$home_content;
    }

   public static function saveForumQuote($w3)
    {
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['ts'] = time();
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
       $_FIELD['userID']       = $w3->getAuthenticateAdminUserID();
       $_FIELD['discussionID'] = $_FIELD['postID'];
       $_FIELD['quoteID']      = $_FIELD['quoteID'];
       $_FIELD['enabled']      = WM3_cENABLED;
       wm3Sql::saveAllTableFields('_forums_posts',$_FIELD,array('replyID','unlink_quote'));
       
       // Send notice mail to all discussion users
       wm3Forum::sendEmailForumReply($w3,$w3->getVariable('postID','post'));
      }
     return wm3Sql::getLastInsertID();
    }

   public static function addForumReply($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Forum::getForumPostFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";

     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID','both'),1,true);

     switch($error)
      {
       case 1: // No post
        {
         $_STYLE['post']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       case 2: // Invalid discussion
        {
         //$_STYLE['post']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid discussion";//$w3->getWord(2);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['forumID']     = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']     = WM3_cENABLED;
		 $_FIELD['render_mode'] = WM3_cRENDER_MODE_BB_CODE;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1025);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_FORUM_REPLY;
     $next_action_label = $w3->getWord(191);
     $_FIELD['pageID']  = $w3->getVariable('pageID','both');
     $_FIELD['forumID'] = $w3->getVariable('forumID','both');
     $_FIELD['postID'] = $w3->getVariable('postID','both');
     require(WM3_cPATH_INCLUDE."home_forum_reply_form.inc");
     return $str.$home_content;
    }

   public static function saveForumReply($w3)
    {
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['ts'] = time();
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
       $_FIELD['userID']       = $w3->getAuthenticateAdminUserID();
       $_FIELD['discussionID'] = $_FIELD['postID'];
       $_FIELD['quoteID']      = 0;
       $_FIELD['enabled']      = WM3_cENABLED;
       wm3Sql::saveAllTableFields('_forums_posts',$_FIELD,array('replyID','unlink_quote'));
       
       // Send notice mail to all discussion users
       wm3Forum::sendEmailForumReply($w3,$w3->getVariable('postID','post'));
      }
     return wm3Sql::getLastInsertID();
    }

   public static function editForumReply($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                               WHERE postID = '".$w3->getVariable('replyID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumPostFieldsArray(),$row);
       // Default value for fields not in $row object
	   $_FIELD['quoteID'] = $row->quoteID;
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Forum::getForumPostFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');

     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID','both'),1,true);

     switch($error)
      {
       case 1: // No post
        {
         $_STYLE['post']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       case 2: // Invalid discussion
        {
         //$_STYLE['post']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid discussion";//$w3->getWord(29);
         break;
        }
       default:
        {
		 $_FIELD['unlink_quote'] = WM3_cDISABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit reply";//$w3->getWord(2);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_FORUM_REPLY;
     $next_action_label = $w3->getWord(29);
     $_FIELD['pageID']  = $w3->getVariable('pageID','both');
     $_FIELD['forumID'] = $w3->getVariable('forumID','both');
     $_FIELD['postID']  = $w3->getVariable('postID','both');
     $_FIELD['replyID'] = $w3->getVariable('replyID','both');
	 $_FIELD['quoteID'] = $_FIELD['quoteID'];
	 $quote_text = "";
     if($_FIELD['quoteID'] != 0)
	  {
	   $quote_text = wm3Forum::renderForumQuoteText($w3,$_FIELD['quoteID']);
      }
	 $quote_text .=  wm3Section::makeFormItem($w3,$_STYLE['quoteID'],$w3->getWord(1592),wm3Util::checkboxEnabled('unlink_quote',$_FIELD['unlink_quote']));
     require(WM3_cPATH_INCLUDE."home_forum_quote_form.inc");
     return $str.$home_content;
    }

   public static function updateForumReply($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
	 if($_FIELD['unlink_quote']) $quoteID = 0; else $quoteID = $_FIELD['quoteID'];
     if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	    $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	  $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                       SET   post         =  '".$_FIELD['post']."',
                             render_mode  =  '".$_FIELD['render_mode']."',
                             quoteID      =  '$quoteID'
                       WHERE postID       =  '".$_FIELD['replyID']."'
					     AND discussionID != '0'");
     return $_FIELD['replyID'];
    }

   public static function addForumDiscussion($w3,$error = 0)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Forum::getForumPostFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     // Fields for paging default value
     $pg = $filter = "";

     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID','both'),1,true);

     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // No post
        {
         $_STYLE['post']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       case 3: // Invalid forum
        {
         //$_STYLE['post']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid forum";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['forumID']     = $w3->getVariable('categoryID','get'); // Take categoryID from get
		 $_FIELD['render_mode'] = WM3_cRENDER_MODE_BB_CODE;
         $_FIELD['enabled']     = WM3_cENABLED;

         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1024);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_FORUM_DISCUSSION;
     $next_action_label = $w3->getWord(191);
     $_FIELD['pageID']  = $w3->getVariable('pageID','both');
     $_FIELD['forumID'] = $w3->getVariable('forumID','both');
     require(WM3_cPATH_INCLUDE."home_forum_discussion_form.inc");
     return $str.$home_content;
    }

   public static function saveForumDiscussion($w3)
    {
     if(wm3Session::actionAllowed($w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['ts'] = time();
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
       $_FIELD['userID']       = $w3->getAuthenticateAdminUserID();
       $_FIELD['discussionID'] = 0;
       $_FIELD['quoteID']      = 0;       
       $_FIELD['enabled']      = WM3_cENABLED;
       wm3Sql::saveAllTableFields('_forums_posts',$_FIELD,array('replyID','unlink_quote'));
      }
     $lastID = wm3Sql::getLastInsertID();
	 wm3Forum::setForumDiscussionRead($w3,$lastID);
	 return $lastID;
    }

   public static function editForumDiscussion($w3,$error = 0)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                               WHERE postID = '".$w3->getVariable('postID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumPostFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Forum::getForumPostFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');

     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID','both'),1,true);

     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(8);
         break;
        }
       case 2: // No post
        {
         $_STYLE['post']      = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(132);
         break;
        }
       case 3: // Invalid forum
        {
         //$_STYLE['post']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid forum";//$w3->getWord(29);
         break;
        }
       case 4: // Invalid discussion
        {
         //$_STYLE['post']    = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = "Invalid discussion";//$w3->getWord(29);
         break;
        }
       default:
        {
         // Default values for the form
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = "Edit forum discussion";//$w3->getWord(1);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_FORUM_DISCUSSION;
     $next_action_label = $w3->getWord(191);
     $_FIELD['pageID']  = $w3->getVariable('pageID','both');
     $_FIELD['forumID'] = $w3->getVariable('forumID','both');
     require(WM3_cPATH_INCLUDE."home_forum_discussion_form.inc");
     return $str.$home_content;
    }

   public static function updateForumDiscussion($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	    $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	  $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                   SET   title        = '".$_FIELD['title']."',
                             post         = '".$_FIELD['post']."',
                             render_mode  = '".$_FIELD['render_mode']."'
                       WHERE postID       = '".$_FIELD['postID']."'
					     AND discussionID = '0'");
     return $_FIELD['postID'];
    }

   public static function getForumCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function checkForumCategoryError($w3)
    {
     return $w3->getSectionObj()->checkCategoryError($w3);
    }

   public static function addForumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editForumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function saveForumCategory($w3)
    {
     return $w3->getSectionObj()->saveCategory($w3);
    }

   public static function updateForumCategory($w3)
    {
     return $w3->getSectionObj()->updateCategory($w3);
    }

   public static function disableForumCategory($categoryID)
    {
	// TODO cancellare anche tutti i forum della categoria con i relativi post
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableForumCategory($categoryID)
    {
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteForumCategory($w3,$categoryID)
    { 
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE categoryID = '$categoryID'");
     while($row = mysql_fetch_object($rs))
	  {
	   wm3Forum::deleteForum($w3,$row->forumID);
	  }
     wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_categories WHERE categoryID = '$categoryID'");
     wm3Sql::sqlQuery("UNLOCK TABLES");
    }

   public static function selectForumCategory($w3,$name,$categoryID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$name,$categoryID,$all,$admin);
    }

   public static function getForumCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($categoryID);
    }

   public static function getForumModerator($forumID)
    {
     // Get moderetor for $forumID
     $rs = wm3Sql::sqlQuery("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE forumID = '$forumID'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->userID;
    }

   public static function existsForumReply($forumID,$discussionID,$replyID)
    {
     // Return true if discussion with postID exists and its a discussion of forumID else return false 
     $rs = wm3Sql::sqlQuery("SELECT postID
	                         FROM  ".WM3_cCONFIG_DB_PREFIX."_forums_posts,
							       ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = '$forumID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '$discussionID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID = '$replyID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums.forumID");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
    }

   public static function existsForumDiscussion($forumID,$discussionID)
    {
     // Return true if discussion with postID exists and its a discussion of forumID else return false 
     $rs = wm3Sql::sqlQuery("SELECT postID
	                         FROM  ".WM3_cCONFIG_DB_PREFIX."_forums_posts,
							       ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = '$forumID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '0'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID = '$discussionID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums.forumID");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
    }

   public static function existsForum($forumID)
    {
     // Return true if the forum with forumID exists else return false
     $rs = wm3Sql::sqlQuery("SELECT forumID FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE  forumID = '$forumID'");
     if(mysql_num_rows($rs) == 1) return true;
	 else                         return false;
    }

   public static function getForumList($w3,$currentID = 0,$admin = true,$user = false)
    {
     // Get forum list (admin,user and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID','both');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_forums.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter','both'); // Search field
     $pg     = $w3->getVariable('pg','both');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_forums.title LIKE '%$filter%'";
     	         }
     else        { if(!$categoryID) if(!$user) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_title       = 40;
                 $width_permissions = 30;
	             if(!$user) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_FORUM;
	             else       $search_form_link = WM3_cCONFIG_USER_FILE;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 6; $buttons = 3;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link         = "&pageID=$pageID";
                 $search_form_link  = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FORUM."$page_link";
                 $base_link         = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title       = 50;
                 $width_permissions = 50;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_forums.enabled*".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_forums.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_forums.languageID='".WM3_cLANGUAGE_ALL."')";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FORUMS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_forums.title DESC";
	 if(!$user)
	  {
       $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_forums.*
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_forums_categories,".WM3_cCONFIG_DB_PREFIX."_forums
                 WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_forums.categoryID
                 $query_filter";
	  }
	 else
	  {
       $query = "SELECT *
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_forums
                 WHERE  userID = '".$w3->getAuthenticateUserID()."'
                 $query_filter";
	  }
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'forumID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
	 $_SEP  = $w3->getSkinObj()->getSeparator();
     $_PSEP = $w3->getSkinObj()->getPathSeparator();
     require(WM3_cPATH_INCLUDE."admin_forum_search_form.inc");
     if($admin)
	  {
	   if(!$user) array_push($_CONTENTS,"<a href=\"$base_link\">".$w3->getWord(974)."</a>");
	   else       array_push($_CONTENTS,$w3->getWord(1545));
      }
     else       array_push($_CONTENTS,"<a href=\"$base_link$page_link\">".$w3->getWord(974)."</a>");
     if($categoryID && !$user)
      {
       if($admin) array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       array_push($_CONTENTS," $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) array_push($_CONTENTS," $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_FORUM,"action_add.png","","",$w3->getWord(356),0,16,16));
       //else       array_push($_CONTENTS," $_SEP Make a question TODO".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_ADD_FORUM,"action_down.png","","",$w3->getWord(356),0,16,16));
      }
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array($width_title,$width_permissions,40,0),array(194,-1,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&forumID=$row->forumID";
       if($allowed) $allowed_link = $base_allowed_link."&forumID=$row->forumID";
       $moderator   = wm3User::getUserLogin($row->userID);
       $group       = wm3User::getGroupName(wm3User::getGroupID($row->userID));
       $permissions = wm3Forum::getForumPermissionsLegend($row);
       if($categoryID) {
                        if($admin) array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>(0 discussions, 0 replies)<p><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i></p>");
                        else       array_push($_CONTENTS,"<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_FORUM.">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a>(0 discussions, 0 replies)<p><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i></p>");
                       }
       else            {
       	                // For the search in all categories (TODO for the forums)
                        if($admin) 
                         {
						  if(!$user) array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>(".$w3->getWord(659)." <a href=\"".$base_link.$search_link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$row->categoryID)."</a>)");
                          else       array_push($_CONTENTS,wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>(0 discussions, 0 replies)<p><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i></p>");
                         }
                        else array_push($_CONTENTS,"<a href=$link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_SINGLE_FORUM.">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a><br>(".$w3->getWord(659)." <a href=\"".$link.$page_link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$row->categoryID)."</a>)");
                       }
       array_push($_WIDTHS,$width_title);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         array_push($_CONTENTS,$permissions);
         array_push($_CONTENTS,"$lang_flag (".$w3->getWord(999)." $moderator, group $group)");
         array_push($_WIDTHS,30,30);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_FORUM,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_FORUM,"action_enable.png",$w3->getWord(181)));
         array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM,"action_edit.png",$w3->getWord(178)));
         array_push($_CONTENTS,wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_FORUM,"action_delete.png",$w3->getWord(179),$w3->getWord(997)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FORUM,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->forumID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
       if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link."&action=".WM3_cACTION_SHOW_FORUM.$id_link.$search_link);
       else       $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$page_link."&action=".WM3_cACTION_SHOW_FORUM.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function checkForumError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray());
     if($_FIELD['title']=='') return 1;
	 if(!$w3->getSectionObj()->existsCategory($_FIELD['categoryID'])) return 2;
     if($_FIELD['topic']=='') return 3;
     return 0;
    }

   public static function addForum($w3,$error = 0,$user = false)
    {
     // Take variables value and set correct form style    
     $_STYLE = wm3Skin::getFormStyleArray(wm3Forum::getForumFieldsArray());
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray());
     // Fields for paging default value
     $pg = $filter = ""; 
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(166);
         break;
        }
       case 2: // Invalid forums category
        {
         $_STYLE['categoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
         $form_title = "Invalid category";//$w3->getWord(29);
         break;
        }
       case 3: // No topic
        {
         $_STYLE['topic']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(1027);
         break;
        }
       default:
        {
         // Default values for the form
         $_FIELD['categoryID'] = $w3->getVariable('categoryID','get'); // Take categoryID from get
         $_FIELD['enabled']    = WM3_cENABLED;
         $_STYLE['formTitle']  = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1453);
       	}
      }
     $next_action       = WM3_cACTION_SAVE_FORUM;
     $next_action_label = $w3->getWord(191);
     if($user) require(WM3_cPATH_INCLUDE."user_forum_form.inc");
	 else      require(WM3_cPATH_INCLUDE."admin_forum_form.inc");

     return $content;
    }

   public static function editForum($w3,$error = 0,$user = false)
    {
     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                               WHERE forumID = '".$w3->getVariable('forumID','get')."'");
       $row = mysql_fetch_object($rs);
	   if(!$row) return wm3Section::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray());

     $_STYLE = wm3Skin::getFormStyleArray(wm3Forum::getForumFieldsArray());
     $pg     = $w3->getVariable('pg','both');
     $filter = $w3->getVariable('filter','both');
     switch($error)
      {
       case 1: // No title
        {
         $_STYLE['title']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(166);
         break;
        }
       case 2: // Invalid forums category
        {
         $_STYLE['categoryID'] = WM3_cSKIN_ERROR;
         $_STYLE['formTitle']  = WM3_cSKIN_ERROR;
         $form_title = "Invalid category";//$w3->getWord(29);
         break;
        }		
       case 3: // No topic
        {
         $_STYLE['topic']     = WM3_cSKIN_ERROR;
         $_STYLE['formTitle'] = WM3_cSKIN_ERROR;
         $form_title = $w3->getWord(1027);
         break;
        }
       default:
        {
         $_STYLE['formTitle'] = WM3_cSKIN_NO_ERROR;
         $form_title = $w3->getWord(1028);
       	}
      }
     $next_action       = WM3_cACTION_UPDATE_FORUM;
     $next_action_label = $w3->getWord(29);
     if($user) require(WM3_cPATH_INCLUDE."user_forum_form.inc");
	 else      require(WM3_cPATH_INCLUDE."admin_forum_form.inc");
     return $content;
    }

   public static function saveForum($w3,$user = false)
    {//TODO controllare dipendenze per i campi group_open, users_read, users_write, users_open, visitors_read, visitors_write, visitors_open (esempio se posso scrivere posso anche leggere)
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
	 if($user) $_FIELD['userID'] = $w3->getAuthenticateUserID();
     wm3Sql::saveAllTableFields('_forums',$_FIELD);
     return wm3Sql::getLastInsertID();
    }

   public static function updateForum($w3,$user = false)
    {//TODO controllare dipendenze per i campi group_open, users_read, users_write, users_open, visitors_read, visitors_write, visitors_open (esempio se posso scrivere posso anche leggere)
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray(),WM3_cQUOTE_DB);
	 if($user) $_FIELD['userID'] = $w3->getAuthenticateUserID();
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                       SET   title          = '".$_FIELD['title']."',
                             categoryID     = '".$_FIELD['categoryID']."',
                             topic          = '".$_FIELD['topic']."',
                             userID         = '".$_FIELD['userID']."',
                             expire_days    = '".$_FIELD['expire_days']."',
                             denied_words   = '".$_FIELD['denied_words']."',
                             users_read     = '".$_FIELD['users_read']."',
                             visitors_read  = '".$_FIELD['visitors_read']."',
                             users_write    = '".$_FIELD['users_write']."',
                             visitors_write = '".$_FIELD['visitors_write']."',                             
                             group_open     = '".$_FIELD['group_open']."',
                             users_open     = '".$_FIELD['users_open']."',
                             visitors_open  = '".$_FIELD['visitors_open']."',
                             enabled        = '".$_FIELD['enabled']."',
                             languageID     = '".$_FIELD['languageID']."'
                       WHERE forumID        = '".$_FIELD['forumID']."'");
     return $_FIELD['forumID'];
    }

   public static function selectForum($w3,$name,$forumID,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$name,$forumID,$all,$admin,"title","forumID");
    }

   public static function duplicateForum($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE forumID = '".$w3->getVariable('forumID','get')."'");
     $row = mysql_fetch_object($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts'] = time();
       wm3Sql::saveAllTableFields('_forums',$_FIELD);
       return wm3Sql::getLastInsertID();
      }
    }

   public static function disableForum($w3,$forumID,$user = false)
    {
	 if($user) wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cDISABLED."' WHERE forumID = '$forumID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cDISABLED."' WHERE forumID = '$forumID'");
	}

   public static function enableForum($w3,$forumID,$user = false)
    {
	 if($user) wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cENABLED."' WHERE forumID = '$forumID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cENABLED."' WHERE forumID = '$forumID'");
	}
   
   public static function deleteForum($w3,$forumID,$user = false)
    {
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
	 if($user) {
		        $userID = $w3->getAuthenticateUserID();
		        if(wm3Forum::getForumModerator($forumID) == $userID)
				 {
		          $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
				  while($row = mysql_fetch_object($rs))
				   {
				    wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WHERE postID = '$row->postID'");
			       }
		          wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
		          wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE forumID = '$forumID' AND userID='$userID'");
			     }
			   }
	 else      {
		        $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
				while($row = mysql_fetch_object($rs))
				 {
				  wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WHERE postID = '$row->postID'");
			     }
		        wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
		        wm3Sql::sqlQuery("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE forumID = '$forumID'");
			   }
     wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function selectForumExpireDays($name,$value,$w3)
    {
     // Make forum expire days select
     for($i = 0; $i <= 15; $i++)
      {
       if($i <= 10) $v = $i;
       if($i == 11) $v = 15;
       if($i == 12) $v = 20;
       if($i == 13) $v = 30;
       if($i == 14) $v = 60;
       if($i == 15) $v = 90;
       $_VALUES[$i] = $v;
       if($i == 0) $_LABELS[$i] = $w3->getWord(1003);
       else        if($i == 1) $_LABELS[$i] = $v." ".$w3->getWord(1005);
                   else        $_LABELS[$i] = $v." ".$w3->getWord(1006);
      }
     return wm3Util::selectArray($name,$_LABELS,$_VALUES,$value);
    }

   public static function getForumPermissionsLegend($row)
    {
     $visitors_permissions = "";
     if($row->visitors_read)  $visitors_permissions .= "read, ";
     if($row->visitors_write) $visitors_permissions .= "write, ";
     if($row->visitors_open)  $visitors_permissions .= "open discussion";
     if($visitors_permissions == "") $visitors_permissions .= "no access";

     $users_permissions = "";
     if($row->users_read)  $users_permissions .= "read, ";
     if($row->users_write) $users_permissions .= "write, ";
     if($row->users_open)  $users_permissions .= "open discussion";
     if($users_permissions == "") $users_permissions .= "no access";

     $group_permissions = "read, write";
     if($row->users_open)  $group_permissions .= ", open discussion";

     $str = "Visitors: $visitors_permissions<br>
             Users: $users_permissions<br>
             Group: $group_permissions";
     return $str;
    }

   public static function renderForumHeader($w3,$forumID,$columns,$bottom = false,$button_discussion = "",$button_reply = "",$no_search_form = false,$no_info = false,$search = false,$total_search_items = 0)
    {
     $_CONTENTS = array();
	 $filter       = $w3->getVariable('filter','both'); // Search field
	 $filter_check = $w3->getVariable('filter_check','both');
     $pageID = $w3->getVariable('pageID','both');
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=$pageID";
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE forumID = '$forumID'");
     $total_items = mysql_num_rows($rs);
     if($total_items == 1) $row = mysql_fetch_object($rs);

     if(!$no_search_form)
      {
       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SEARCH_FORUM.$page_link;
       require(WM3_cPATH_INCLUDE."home_forum_search_form.inc");
      }
     else $search_form = "";

     $link = $base_link.$page_link;
	 $all_forum     = "<a href=\"$link\">".$w3->getWord(992)."</a>";
	 if($total_items == 1)
	  {
       $_PSEP = $w3->getSkinObj()->getPathSeparator();
	   $category_name = " ".$_PSEP." ".wm3Forum::getForumCategoryName($w3,$row->categoryID);
	   $forum_title   = " ".$_PSEP." <a href=\"$link&forumID=$forumID&action=".WM3_cACTION_SHOW_FORUM_DISCUSSIONS."\">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a>";
      }
	 else $category_name = $forum_title = "";
     array_push($_CONTENTS,$all_forum.$category_name.$forum_title);
     $button = $button_discussion." ".$button_reply;
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns,$search_form);
     if(!$no_info)
	  {
	   $_PERMISSIONS = wm3Forum::getForumPermissionsArray($w3,$forumID);
	   $permissions = ""; $i = 0;
	   foreach($_PERMISSIONS as $key => $value)
	    {
         if($_PERMISSIONS[$key]) $permissions .= " ".$w3->getWord(1694+$i).",";
		 $i++;
        }
	   if(!$permissions) $permissions = $w3->getWord(1010);
	   $you_can = "You can:".rtrim($permissions,',').".";
	   $str .= wm3Section::makeItemList($w3,1,array(100),array("<b>".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</b><br><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i><br>Creato il ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage()).", moderator: <b>".wm3User::getUserLogin($row->userID)."</b> (group: ".wm3User::getGroupName(wm3User::getGroupID($row->userID)).")<br>$you_can<br><br>$button"),false,array($columns));
      }
	 if($search)   $str .= wm3Section::makeItemList($w3,1,array(100),array("<b>$total_search_items matches for \"".wm3Util::renderContent($w3,$filter,WM3_cRENDER_MODE_PLAIN_TEXT)."\""),false,array($columns));
     if($bottom)   $str .= wm3Section::makeBottomList($w3,$columns);
     return $str;
    }

   private static function countForumDiscussions($forumID)
    {
     // Get the number of discussions for a forum
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_forums_posts","WHERE forumID = '$forumID' AND discussionID = '0'");
     return $total;
    }

   private static function countForumReplies($forumID)
    {
     // Get the number of replies for a forum
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_forums_posts","WHERE forumID = '$forumID' AND discussionID <> '0'");
     return $total;
    }

   private static function countForumDiscussionReplies($forumID,$discussionID)
    {
     // Get the number of replies for a single discussion in a forum
     $total = wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_forums_posts","WHERE forumID = '$forumID' AND discussionID = '$discussionID'");
     return $total;
    }

   private static function renderForumPostDate($w3,$postID)
    {
     // Render the date for a discussion/reply

     $rs = wm3Sql::sqlQuery("SELECT ts FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE postID = '$postID'");
     if(mysql_num_rows($rs) == 0) return "-";
     $row = mysql_fetch_object($rs);
     return wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
    }

   private static function renderUserPostID($w3,$postID,$link = true)
    {
     // Render user login for a postID
     $rs = wm3Sql::sqlQuery("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  postID = '$postID'");
     if(mysql_num_rows($rs) != 1) return '';
     $row = mysql_fetch_object($rs);
	 $login = wm3User::getUserLogin($row->userID);
	 if($link && $login) $login = wm3Util::makeLink($w3,WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_USER_INFORMATIONS."&userID=$row->userID",$login);
	 if(!$login) $login = $w3->getWord(988);
	 return $login;
    }

   private static function getLastReplyDiscussionID($postID)
    {
     // Get discussionID of a postID
     $rs = wm3Sql::sqlQuery("SELECT discussionID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  postID = '$postID' AND discussionID != '0'");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->discussionID;
    }

   private static function getLastDiscussionReplyID($discussionID)
    {
     // Get the last reply postID of discussionID
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  discussionID = '$discussionID'
                             ORDER BY ts DESC LIMIT 0,1");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->postID;
    }

   private static function getLastDiscussionID($forumID)
    {
     // Get the last discussion postID of forumID
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  forumID = '$forumID' AND discussionID = '0'
                             ORDER BY ts DESC LIMIT 0,1");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->postID;
    }

   private static function getLastForumReplyID($forumID)
    {
     // Get the last reply postID of forumID
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  forumID = '$forumID' AND discussionID <> '0'
                             ORDER BY ts DESC LIMIT 0,1");
     if(mysql_num_rows($rs) != 1) return 0;
     $row = mysql_fetch_object($rs);
     return $row->postID;
    }

   private static function renderForumQuoteText($w3,$postID)
    {
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE postID = '$postID'");
     if(mysql_num_rows($rs) != 1)
      {
       $post   = "???"; // TODO post deleted by moderator or ...???
       $author = "";
      }
     else
      {
       $row = mysql_fetch_object($rs);
       $author = wm3User::getUserLogin($row->userID)." ".$w3->getWord(1588)."<br>";
       if(!$author) $author = $w3->getWord(988);
	   $post = wm3Util::renderContent($w3,$row->post,$row->render_mode);
      }
     $str = $author;

	 ob_start();
	 $quote_open  = $w3->getSkinObj()->getQuoteOpen();
	 $content     = $post;
	 $quote_close = $w3->getSkinObj()->getQuoteClose();
     require($w3->getSkinObj()->getForumQuote());
     $str .= ob_get_contents();
	 ob_end_clean();

     return $str;
    }

   private static function isForumDiscussionRead($w3,$postID)
    {
	 if(!$w3->getAuthenticateAdminUserID()) return true; // No user logged

     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                             WHERE  postID = '$postID' AND userID = '".$w3->getAuthenticateAdminUserID()."'");
     if(mysql_num_rows($rs) == 0) return false; // Not jet readed

     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                             WHERE  postID = '$postID'
							   AND  userID = '".$w3->getAuthenticateAdminUserID()."'
							   AND  read_ts < (SELECT MAX(ts) AS max
							                   FROM   ".WM3_cCONFIG_DB_PREFIX."_forums_posts
											   WHERE  discussionID = '$postID'
											      OR (discussionID = '0' AND postID = '$postID')
											  )");
     if(mysql_num_rows($rs) == 0) return true;
     else                         return false;
	}

   private static function isForumDiscussionLocked($w3,$postID)
    {
     $rs = wm3Sql::sqlQuery("SELECT locked FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  discussionID = '0' AND postID = '$postID'");
     if(mysql_num_rows($rs) != 1) return true;
     $row = mysql_fetch_object($rs);
     return $row->locked;
	}

   private static function isForumDiscussion($w3,$postID)
    {
     $rs = wm3Sql::sqlQuery("SELECT discussionID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  discussionID = '0' AND postID = '$postID'");
     if(mysql_num_rows($rs) == 1) return true;
     else                         return false;
	}

   public static function hitForumDiscussion($w3)
    {
     $discussionID = $w3->getVariable('postID','both');
	 if(!wm3Session::forumPostAllowed($discussionID,WM3_cSESSION_HIT)) return;
	 else wm3Session::forumPostProtect($discussionID,WM3_cSESSION_HIT);
     wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                       SET    hits         = hits + 1
                       WHERE  postID       = '$discussionID'
					     AND  discussionID = '0'");
    }

   private static function setForumDiscussionRead($w3,$postID)
    {
	 $userID = $w3->getAuthenticateAdminUserID();
	 if($userID && $postID != 0)
	  {
       wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
       $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                               WHERE  postID = '$postID' AND userID = '$userID'");
       if(mysql_num_rows($rs) != 1) // Readed for first time
        {
	     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostReadFieldsArray(),WM3_cQUOTE_DB);
	     $_FIELD['userID']  = $userID;
	     $_FIELD['postID']  = $postID;
         $_FIELD['read_ts'] = time();
         wm3Sql::saveAllTableFields('_forums_posts_read',$_FIELD);
	    }
	   else // Post already readed in the past ("read_ts" need to update)
	    {
		 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                           SET    read_ts = '".time()."'
			 		       WHERE  postID  = '$postID' AND userID = '$userID'");
        }
	   wm3Sql::sqlQuery("UNLOCK TABLES");
	  }
	}

   public static function expireForumDiscussions($w3)
    {
	 // Remove all the discussions with more then "expire_days" days of inactivity
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts WRITE");
     $rs = wm3Sql::sqlQuery("SELECT ".WM3_cCONFIG_DB_PREFIX."_forums.expire_days * 86400 AS expire_days,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts.ts
				             FROM   ".WM3_cCONFIG_DB_PREFIX."_forums,
				                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '0'
			   		           AND  ".WM3_cCONFIG_DB_PREFIX."_forums.expire_days != '0'");
      $ts = time();
      while($row = mysql_fetch_object($rs))
       {
		// Get last reply ts
        $rs_last = wm3Sql::sqlQuery("SELECT ts FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE discussionID = '$row->postID' ORDER BY ts DESC LIMIT 0,1");
		if(mysql_num_rows($rs_last) != 1) $last_ts = $row->ts;
		else
		 {
		  $row_last = mysql_fetch_object($rs_last);
          $last_ts = $row_last->ts;
	     }
		$end_ts = $last_ts+$row->expire_days;
		// Delete discussion if last discussion post was written $row->expire_days ago
		if($end_ts <= $ts) wm3Forum::deleteForumDiscussion($w3,$row->postID);
       }
     wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function sendEmailForumReply($w3,$postID)
    {
	 // Send notice email to all current discussion users (except the logged user)
	 // TODO controllare bene che funzioni e che la traduzione nelle varie lingue sia ok!
     $rs = wm3Sql::sqlQuery("SELECT ".WM3_cCONFIG_DB_PREFIX."_forums.title AS forum_title,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums.forumID,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts.*,
	                                ".WM3_cCONFIG_DB_PREFIX."_users.email
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_forums,
	                                ".WM3_cCONFIG_DB_PREFIX."_forums_posts,
							        ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.userID = ".WM3_cCONFIG_DB_PREFIX."_users.userID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.userID != '".$w3->getAuthenticateAdminUserID()."'
                               AND  (".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '$postID' OR ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID = '$postID')
                             GROUP BY userID");
      while($row = mysql_fetch_object($rs))
       {
		$discussion_url = "http://".$w3->getPreferences('site_address')."/".WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_PAGES."&pageID=".$w3->getVariable('pageID','post')."&forumID=$row->forumID&postID=$postID&action=".WM3_cACTION_SHOW_FORUM_REPLIES;
		$sender     = $w3->getPreferences('service_email');
		$subject    = "You received a response from the forum: $row->forum_title (".$w3->getPreferences('site_address').")";
		$email_body = "Someone has replied to your message,\nyou can see your answer here:\n\n$discussion_url\n";
        @mail($row->email,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
       }
	}

  }

?>
