<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Language
  {
   private $_WORD,$_WORD_CATEGORY,$_WORD_EXPANSION,$_HELP;
   private $_MONTH,$_DAY_OF_THE_WEEK,$_ZODIAC_SIGN;
   
   function __construct($languageID,$setup = false)
    {
     if($setup) $this->getSetupLanguageFile($languageID);
	 else       $this->getLanguageFile($languageID);
    }

   public static function getLanguageFieldsArray()
    {
     return array('languageID','','ts');//TODO
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_LANGUAGE:
        {
         wm3Language::disableLanguage($w3->getVariable('languageID','get'));
         return wm3Language::getLanguageList($w3,$w3->getVariable('languageID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_LANGUAGE:
        {
         wm3Language::enableLanguage($w3->getVariable('languageID','get'));
         return wm3Language::getLanguageList($w3,$w3->getVariable('languageID','get'));
         break;
        }
/*       case WM3_cACTION_EDIT_MESSAGE:
        {
         return wm3Message::editMessage($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MESSAGE:
        {
         $error = wm3Message::checkMessageError($w3);
         if(!$error)
          {
           $lastID = wm3Message::updateMessage($w3);
           // $msg= message udated... //TODO
           return wm3Message::getMessageList($w3,$lastID);
          }
         else return wm3Message::editMessage($w3,$error);
         break;
        }*/
       default:
        {
         return wm3Language::getLanguageList($w3);
        }
      }
    }

   public static function getLanguageList($w3,$currentID = 0,$admin = true)
    {
     // Get languages list (admin side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg','both');
     $columns = 3; $buttons = 1;

	 /*{$w3->getHomeLanguage();//...
       if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
      }*/

     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $id_link = "";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_languages.languageID";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages";
     $rs = wm3Sql::sqlQuery($query.$order_by); // Do the query without "limit"
     $total_items = mysql_num_rows($rs);
     if($total_items % $max_page_items == 0 && $pg == (int)($total_items / $max_page_items)) $pg--;
	 if($currentID)
	  {
	   $position = wm3Sql::getRSPosition($rs,'languageID',$currentID);
	   $pg = (int)($position / $max_page_items);
      }
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0 && $admin) $rs = wm3Sql::sqlQuery($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list header
     $_CONTENTS = array();
     array_push($_CONTENTS,$w3->getWord(1297));
     $str = wm3Section::makeHeaderList($w3,$_CONTENTS,$columns);

     // Create list caption
     if($admin) $str .= wm3Section::makeCaptionList($w3,array(30,70,0),array(907,1671),$buttons);

     // Check if there are any items (and exit with a message if there are 0 items)
     if($total_items == 0) return $str.wm3Section::makeEmptyItemsList($w3,$columns,593);

     // Create list items
     $p = 0;
     while($row = mysql_fetch_object($rs))
      {
       $_CONTENTS = array(); $_WIDTHS = array();
       $link = $base_link.$id_link.$extra_link."&languageID=$row->languageID";
       if($allowed) $allowed_link = $base_allowed_link."&languageID=$row->languageID";
       array_push($_CONTENTS,$row->name); array_push($_WIDTHS,30);
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag."<br>Language file: ".WM3_cPATH_LANGUAGES.$row->file." (".wm3Folder::renderFileSize($w3,@filesize(WM3_cPATH_LANGUAGES.$row->file)).")";
         array_push($_CONTENTS,$info); array_push($_WIDTHS,70);
         // Buttons
         if($row->enabled) array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_LANGUAGE,"action_disable.png",$w3->getWord(180)));
         else              array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_LANGUAGE,"action_enable.png",$w3->getWord(181)));
         //array_push($_CONTENTS,wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178)));
        }
       else
        {
         if($allowed) array_push($_CONTENTS,wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178)));
        }
       $str .= wm3Section::makeItemList($w3,$p,$_WIDTHS,$_CONTENTS,$row->languageID==$currentID);
       $p++;
      }

     // Create list bottom
     $bottom_content = "";
     if($total_items > $max_page_items)
      {
	   if($admin) $bottom_content = wm3Util::makePagesNavigator($total_items,$max_page_items,$pg,$base_link.$id_link.$search_link);
      }
     $str .= wm3Section::makeBottomList($w3,$columns,$bottom_content);

     return $str;
    }

   public static function disableLanguage($languageID)
    {
	 // Disable a language only if at least one language still enabled
	 wm3Sql::sqlQuery("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_languages WRITE");

	 if(wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_languages","WHERE enabled='".WM3_cENABLED."'") > 1)
	  wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET enabled = '".WM3_cDISABLED."' WHERE languageID = '$languageID'");

	 wm3Sql::sqlQuery("UNLOCK TABLES");
	}

   public static function enableLanguage($languageID)
    {
	 wm3Sql::sqlQuery("UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET enabled = '".WM3_cENABLED."' WHERE languageID = '$languageID'");
	}

   public static function getFirstLanguageEnabled()
    {
	 $rs = wm3Sql::sqlQuery("SELECT languageID FROM ".WM3_cCONFIG_DB_PREFIX."_languages WHERE enabled='".WM3_cENABLED."' LIMIT 1");
	 $row = mysql_fetch_object($rs);
	 return $row->languageID;
	}

   public static function isLanguageEnabled($languageID)
    {
	 if(wm3Sql::countTable(WM3_cCONFIG_DB_PREFIX."_languages","WHERE enabled='".WM3_cENABLED."' AND languageID='$languageID'") == 1) return true;
	 else return false;
	}

   public static function writeCookieHomeLanguageID($languageID = 0)
    {
     if(!isset($_COOKIE['home_languageID']))
      {
	   if(wm3Language::isLanguageEnabled(WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	   else                                                              $languageID = wm3Language::getFirstLanguageEnabled();
       setcookie("home_languageID",$languageID,time()+3600*24*365); // Set default home language if enabled, else get the first enabled language
       return $languageID;
      }
     else 
      {
	   if(!wm3Language::isLanguageEnabled($_COOKIE['home_languageID']))
	    {
		 // Rewrite bad cookies
	     if(wm3Language::isLanguageEnabled(WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	     else                                                              $languageID = wm3Language::getFirstLanguageEnabled();
		 setcookie("home_languageID",$languageID,time()+3600*24*365);
		 return $languageID;
		}
	   if(wm3Language::isLanguageEnabled($languageID))
        {
         setcookie("home_languageID",$languageID,time()+3600*24*365); // New selected language
         return $languageID;
        }
      }
     return $_COOKIE['home_languageID'];
    }

   public static function writeCookieAdminLanguageID($languageID = 0,$setup = false)
    {
	 if($setup) // Do not check for enabled language in database when setup is running
	  {
       if(!isset($_COOKIE['admin_languageID']))
        {
         setcookie("admin_languageID",WM3_cCONFIG_STARTING_LANGUAGE,time()+3600*24*365); // Default admin language
         return WM3_cCONFIG_STARTING_LANGUAGE;
        }
       else 
        {
	     if($_COOKIE['admin_languageID'] < WM3_cLANGUAGE_EN || $_COOKIE['admin_languageID'] > WM3_cLANGUAGE_NL)
	      {
		   // Rewrite bad cookies
		   setcookie("admin_languageID",WM3_cCONFIG_STARTING_LANGUAGE,time()+3600*24*365);
		   return WM3_cCONFIG_STARTING_LANGUAGE;
	  	  }
         if($languageID != 0)
          {
           setcookie("admin_languageID",$languageID,time()+3600*24*365); // New selected language
           return $languageID;
          }
        }
       return $_COOKIE['admin_languageID'];
	  }
	 else
	  {
       if(!isset($_COOKIE['admin_languageID']))
        {
	     if(wm3Language::isLanguageEnabled(WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	     else                                                              $languageID = wm3Language::getFirstLanguageEnabled();
         setcookie("admin_languageID",$languageID,time()+3600*24*365); // Set default admin language if enabled, else get the first enabled language
         return $languageID;
        }
       else 
        {
	     if(!wm3Language::isLanguageEnabled($_COOKIE['admin_languageID']))
	      {
  		   // Rewrite bad cookies
	       if(wm3Language::isLanguageEnabled(WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	       else                                                              $languageID = wm3Language::getFirstLanguageEnabled();
		   setcookie("admin_languageID",$languageID,time()+3600*24*365);
		   return $languageID;
		  }
         if(wm3Language::isLanguageEnabled($languageID))
          {
           setcookie("admin_languageID",$languageID,time()+3600*24*365); // New selected language
           return $languageID;
          }
        }
       return $_COOKIE['admin_languageID'];
      }
    }

   public static function writeCookiePreferencesLanguageID($languageID = 0)
    {
     if(!isset($_COOKIE['preferences_languageID']))
      {
	   if(wm3Language::isLanguageEnabled(WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	   else                                                              $languageID = wm3Language::getFirstLanguageEnabled();
       setcookie("preferences_languageID",$languageID,time()+3600*24*365); // Set default preferences language (admin side) if enabled, else get the first enabled language
       return $languageID;
      }
     else 
      {
	   if(!wm3Language::isLanguageEnabled($_COOKIE['preferences_languageID']))
	    {
		 // Rewrite bad cookies
	     if(wm3Language::isLanguageEnabled(WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	     else                                                              $languageID = wm3Language::getFirstLanguageEnabled();
		 setcookie("preferences_languageID",$languageID,time()+3600*24*365);
		 return $languageID;
		}
       if(wm3Language::isLanguageEnabled($languageID))
        {
         setcookie("preferences_languageID",$languageID,time()+3600*24*365); // New selected language
         return $languageID;
        }
      }
     return $_COOKIE['preferences_languageID'];
    }

   public static function getFormPanel($w3,$languageID,$n)
    {
     // Make language selection form for panel
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                             WHERE enabled='".WM3_cENABLED."'");
     $str = ""; $p = 0;
	 $_STYLE = wm3Skin::getFormStyleArray(array('odd','even'));
     while($row = mysql_fetch_object($rs))
      {
       if($row->languageID == $languageID) $check = "checked"; else $check = "";
	   if($p%2 == 0) $style = $_STYLE['odd']; else $style = $_STYLE['even'];
	   $str .= wm3Section::makeFormItem($w3,$style,
	                                    "<img src=\"".WM3_cPATH_DATA.$row->flag."\" width=\"19\" height=\"13\" border=\"1\">",
										array(wm3Util::inputRadio($n,$row->languageID,$check),$row->name),'','','',0,array(0,100));
       $p++;
      }
     return $str;
    }

   public static function selectLanguage($w3,$name,$languageID,$all = false)
    {
     // Make language select
     $rs = wm3Sql::sqlQuery("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                             WHERE enabled = '".WM3_cENABLED."'");
     if(mysql_num_rows($rs) == 0) $str = ""; else $str = "<select name=\"$name\">";
	 if($all) $str .= wm3Util::inputOption($w3->getWord(1574),WM3_cLANGUAGE_ALL);
     while($row = mysql_fetch_object($rs))
      {
       if($row->languageID == $languageID) $str .= wm3Util::inputOption($row->name,$row->languageID,"selected");
       else                                $str .= wm3Util::inputOption($row->name,$row->languageID);
      }
     $str .= "</select>";
     return $str;
    }

   public static function selectSetupLanguage($w3,$name,$languageID)
    {
     // Make setup language select
     $_DATA = array('English','Italiano','Français','Deutsch','Español','Nederlands');

	 $str = "<select name=\"$name\">";
     for($i = 0; $i < count($_DATA); $i++)
      {
       if($i+1 == $languageID) $str .= wm3Util::inputOption($_DATA[$i],$i+1,"selected");
       else                    $str .= wm3Util::inputOption($_DATA[$i],$i+1);
      }
     $str .= "</select>";
     return $str;
    }

   public static function getFlag($languageID)
    {
	 if($languageID == WM3_cLANGUAGE_ALL) return "flag_all.png";
     $rs = wm3Sql::sqlQuery("SELECT flag FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                             WHERE languageID= '$languageID'");
     $row = mysql_fetch_object($rs);
     return  $row->flag;
    }

   public static function getName($languageID)
    {
     $rs = wm3Sql::sqlQuery("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                             WHERE languageID='$languageID'");
     $row = mysql_fetch_object($rs);
     return  $row->name;
    }

   public static function getFile($languageID)
    {
     $rs = wm3Sql::sqlQuery("SELECT file FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                             WHERE languageID='$languageID'");
	 if(mysql_num_rows($rs) != 1) return "language_en.php";
     $row = mysql_fetch_object($rs);
     return  $row->file;
    }

   public function getLanguageFile($languageID,$path = WM3_cPATH_LANGUAGES)
    {
	 // Default language if other language do not exists
	 $language_file = $path."language_en.php";
     if(file_exists($language_file)) require($language_file);

     // Load current language
	 if($languageID != WM3_cLANGUAGE_EN)
	  {
	   $language_file = $path.wm3Language::getFile($languageID);
	   if(file_exists($language_file)) require($language_file);
      }

     // Override the original language (if override file exists)
     $override_file = $path."override_".substr($language_file,-6,6);
     if(file_exists($override_file)) require($override_file);
    }

   public function getSetupLanguageFile($languageID)
    {
     require(WM3_cPATH_LANGUAGES."language_en.php"); // Default language if other language do not exists
	 if($languageID == WM3_cLANGUAGE_IT) if(file_exists(WM3_cPATH_LANGUAGES."language_it.php")) require(WM3_cPATH_LANGUAGES."language_it.php");
	 if($languageID == WM3_cLANGUAGE_FR) if(file_exists(WM3_cPATH_LANGUAGES."language_fr.php")) require(WM3_cPATH_LANGUAGES."language_fr.php");
	 if($languageID == WM3_cLANGUAGE_DE) if(file_exists(WM3_cPATH_LANGUAGES."language_de.php")) require(WM3_cPATH_LANGUAGES."language_de.php");
	 if($languageID == WM3_cLANGUAGE_ES) if(file_exists(WM3_cPATH_LANGUAGES."language_es.php")) require(WM3_cPATH_LANGUAGES."language_es.php");
	 if($languageID == WM3_cLANGUAGE_NL) if(file_exists(WM3_cPATH_LANGUAGES."language_nl.php")) require(WM3_cPATH_LANGUAGES."language_nl.php");
    }

   public function translate($s)
    {
     // Translate some words from category panels and pages
     if($s == "PANEL_MESSAGES") 	  return $this->_WORD_CATEGORY[0];
     if($s == "PANEL_LOGIN") 		  return $this->_WORD_CATEGORY[1];
     if($s == "PANEL_CHANNELS") 	  return $this->_WORD_CATEGORY[2];
     if($s == "PANEL_SEARCH") 		  return $this->_WORD_CATEGORY[3];
     if($s == "PANEL_HOROSCOPE") 	  return $this->_WORD_CATEGORY[4];
     if($s == "PANEL_NEWSLETTER") 	  return $this->_WORD_CATEGORY[5];
     if($s == "PANEL_SEND_TO_FRIEND") return $this->_WORD_CATEGORY[6];
     if($s == "PANEL_LANGUAGES") 	  return $this->_WORD_CATEGORY[7];
     if($s == "PANEL_ECOMMERCE") 	  return $this->_WORD_CATEGORY[16];
     if($s == "PANEL_SURVEY") 	 	  return $this->_WORD_CATEGORY[18];
     if($s == "PANEL_FORTUNE")		  return $this->_WORD_CATEGORY[30];
     if($s == "PANEL_RSS_FEEDS")	  return $this->_WORD_CATEGORY[31];
     if($s == "PANEL_BIRTHDAY")  	  return $this->_WORD_CATEGORY[32];
     if($s == "PANEL_SPECIAL_OFFER")  return $this->_WORD_CATEGORY[33];
     if($s == "PANEL_CUSTOM")  		  return $this->_WORD_CATEGORY[35];
	 if($s == "PANEL_EXPANSION")	  return $this->_WORD_CATEGORY[36];

     if($s == "PAGE_MARKET") 	    	return $this->_WORD_CATEGORY[11];
     if($s == "PAGE_FAQ") 			    return $this->_WORD_CATEGORY[12];
     if($s == "PAGE_SEARCH_ENGINE") 	return $this->_WORD_CATEGORY[13];
     if($s == "PAGE_USER_REGISTRATION") return $this->_WORD_CATEGORY[14];
     if($s == "PAGE_LINKS") 			return $this->_WORD_CATEGORY[15];
     if($s == "PAGE_STATISTICS") 	    return $this->_WORD_CATEGORY[17];
     if($s == "PAGE_USER_INFORMATIONS") return $this->_WORD_CATEGORY[19];
     if($s == "PAGE_FORUMS")			return $this->_WORD_CATEGORY[21];
     if($s == "PAGE_DOWNLOADS")		    return $this->_WORD_CATEGORY[22];
     if($s == "PAGE_GUESTBOOKS")        return $this->_WORD_CATEGORY[23];
     if($s == "PAGE_DIRECTORIES")       return $this->_WORD_CATEGORY[24];
     if($s == "PAGE_MEDIA_ALBUMS")		return $this->_WORD_CATEGORY[25];
     if($s == "PAGE_CONTACT")		    return $this->_WORD_CATEGORY[26];
     if($s == "PAGE_CHAT")			    return $this->_WORD_CATEGORY[28];
     if($s == "PAGE_WEBMAIL")		    return $this->_WORD_CATEGORY[29];
     if($s == "PAGE_CUSTOM")            return $this->_WORD_CATEGORY[34];
     if($s == "PAGE_EXPANSION")         return $this->_WORD_CATEGORY[36];

     if($s == "MENU_BAR_ITEM_CHANNEL")  return $this->_WORD_CATEGORY[8];
     if($s == "MENU_BAR_ITEM_HOME")     return $this->_WORD_CATEGORY[9];
     if($s == "MENU_BAR_ITEM_ADMIN")    return $this->_WORD_CATEGORY[10];
     if($s == "MENU_BAR_ITEM_USER")     return $this->_WORD_CATEGORY[20];
     if($s == "MENU_BAR_ITEM_EXTERNAL") return $this->_WORD_CATEGORY[27];
	 if($s == "MENU_BAR_ITEM_CUSTOM")   return $this->_WORD_CATEGORY[34];

     return $s;
    }

   public function setWordEpansionArray($array) { $this->_WORD_EXPANSION = $array; }

   public function getWord($i) { if($i >= 0) return $this->_WORD[$i]; else return; }
   
   public function getWordHelp($i) { if($i >= 0) return $this->_HELP[$i]; else return; }
   
   public function getWordCategory($i) { return $this->_WORD_CATEGORY[$i]; }

   public function getWordExpansion($i) { if($i >= 0) return $this->_WORD_EXPANSION[$i]; else return; }

   public function getArrayMonth() { return $this->_MONTH; }

   public function getArrayDayOfTheWeek() { return $this->_DAY_OF_THE_WEEK; }

   public function getArrayZodiacSign($name_only = false)
    {
	 if($name_only)
	  {
	   $array = array();
	   for($i = 0; $i < 12; $i++) array_push($array,$this->_ZODIAC_SIGN[$i][0]);
	   return $array;
      }
	 else return $this->_ZODIAC_SIGN;
	}

  }

?>
